import {Component, OnInit, ChangeDetectionStrategy, Output, EventEmitter} from '@angular/core';
import {BaseDirective} from '@app/shared/directives/base.directive';
import {LanguagesEnum} from '@app/shared/enums/languages.enum';

@Component({
  selector: 'dlcm-language-selector',
  templateUrl: './language-selector.component.html',
  styleUrls: ['./language-selector.component.scss'],
  changeDetection: ChangeDetectionStrategy.OnPush
})
export class LanguageSelectorComponent extends BaseDirective implements OnInit {
  @Output()
  languageEvent: EventEmitter<string>;

  en: string = LanguagesEnum.en;
  fr: string = LanguagesEnum.fr;
  de: string = LanguagesEnum.de;

  constructor() {
    super();
    this.languageEvent = new EventEmitter();
  }

  ngOnInit() {
  }

  useLanguage(language: string) {
    this.languageEvent.emit(language);
  }
}
