import {NgModule} from '@angular/core';
import {RouterModule, Routes} from '@angular/router';
import {CreateView} from '@app/deposit/views/create/create.view';
import {DetailView} from '@app/deposit/views/detail/detail.view';
import {ListView} from '@app/deposit/views/list/list.view';
import {DepositRoutesEnum} from '@app/shared/enums/routes.enum';
import {AppRoutesEnum} from '@app/module/app-routing.module';


const routes: Routes = [
  {
    path: AppRoutesEnum.root,
    component: ListView,
  },
  {
    path: DepositRoutesEnum.detail + AppRoutesEnum.separator + AppRoutesEnum.paramId,
    component: DetailView,
  },
  {
    path: DepositRoutesEnum.create,
    component: CreateView,
  },
];

@NgModule({
  imports: [RouterModule.forChild(routes)],
  exports: [RouterModule],
})
export class DepositRoutingModule {
}
