import {NgModule} from '@angular/core';
import {DepositRoutingModule} from '@app/deposit/deposit-routing.module';
import {DepositState} from '@app/deposit/deposit.state';
import {DepositService} from '@app/deposit/services/deposit.service';
import {ListView} from '@app/deposit/views/list/list.view';
import {SharedModule} from '@app/shared/shared.module';
import {TranslateModule} from '@ngx-translate/core';
import {NgxsModule} from '@ngxs/store';
import {CreateComponent} from './components/create/create.component';
import {DetailComponent} from './components/detail/detail.component';
import {TableComponent} from './components/table/table.component';
import {CreateView} from './views/create/create.view';
import {DetailView} from './views/detail/detail.view';

const views = [
  ListView,
  CreateView,
  DetailView,
];
const containers = [];
const components = [
  TableComponent,
  CreateComponent,
  DetailComponent,
];

@NgModule({
  declarations: [
    ...views,
    ...containers,
    ...components,
  ],
  imports: [
    SharedModule,
    DepositRoutingModule,
    TranslateModule.forChild({}),
    NgxsModule.forFeature([
      DepositState,
    ]),
  ],
  entryComponents: [],
  exports: [
    ...views,
    ...containers,
  ],
  providers: [
    DepositService,
  ],
})
export class DepositModule {
}
