/**
 * DLCM-Solution
 * DLCM application wrapping all modules, All-In-One
 *
 * The version of the OpenAPI document: 1.3.0-SNAPSHOT
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
/* tslint:disable:no-unused-variable member-ordering */

import { Inject, Injectable, Optional }                      from '@angular/core';
import { HttpClient, HttpHeaders, HttpParams,
         HttpResponse, HttpEvent }                           from '@angular/common/http';
import { CustomHttpUrlEncodingCodec }                        from '../encoder';

import { Observable }                                        from 'rxjs';

import { AipModel } from '../model/aip.model';
import { ApplicationRolesModel } from '../model/application-roles.model';
import { BasicAuthClientsModel } from '../model/basic-auth-clients.model';
import { CollectionModel } from '../model/collection.model';
import { DepositsModel } from '../model/deposits.model';
import { DipModel } from '../model/dip.model';
import { DlcmAccessModel } from '../model/dlcm-access.model';
import { DlcmAdminModel } from '../model/dlcm-admin.model';
import { DlcmArchivalStorageModel } from '../model/dlcm-archival-storage.model';
import { DlcmDataMgmtModel } from '../model/dlcm-data-mgmt.model';
import { DlcmIngestModel } from '../model/dlcm-ingest.model';
import { DlcmModel } from '../model/dlcm.model';
import { DlcmPreingestModel } from '../model/dlcm-preingest.model';
import { DlcmPreservationPlanningModel } from '../model/dlcm-preservation-planning.model';
import { DlcmResourceSrvModel } from '../model/dlcm-resource-srv.model';
import { FundingAgenciesModel } from '../model/funding-agencies.model';
import { InstitutionsModel } from '../model/institutions.model';
import { LanguagesModel } from '../model/languages.model';
import { LicensesModel } from '../model/licenses.model';
import { OaiSetsModel } from '../model/oai-sets.model';
import { Oauth2ClientsModel } from '../model/oauth2-clients.model';
import { OrdersModel } from '../model/orders.model';
import { OrganizationalUnitsModel } from '../model/organizational-units.model';
import { PeopleModel } from '../model/people.model';
import { PreservationJobsModel } from '../model/preservation-jobs.model';
import { PreservationPoliciesModel } from '../model/preservation-policies.model';
import { RolesModel } from '../model/roles.model';
import { SipModel } from '../model/sip.model';
import { SubmissionAgreementsModel } from '../model/submission-agreements.model';
import { SubmissionPoliciesModel } from '../model/submission-policies.model';
import { UsersModel } from '../model/users.model';

import { BASE_PATH, COLLECTION_FORMATS }                     from '../variables';
import { Configuration }                                     from '../configuration';


@Injectable({
  providedIn: 'root'
})
export class DlcmService {

    protected basePath = 'http://localhost';
    public defaultHeaders = new HttpHeaders();
    public configuration = new Configuration();

    constructor(protected httpClient: HttpClient, @Optional()@Inject(BASE_PATH) basePath: string, @Optional() configuration: Configuration) {

        if (configuration) {
            this.configuration = configuration;
            this.configuration.basePath = configuration.basePath || basePath || this.basePath;

        } else {
            this.configuration.basePath = basePath || this.basePath;
        }
    }

    /**
     * @param consumes string[] mime-types
     * @return true: consumes contains 'multipart/form-data', false: otherwise
     */
    private canConsumeForm(consumes: string[]): boolean {
        const form = 'multipart/form-data';
        for (const consume of consumes) {
            if (form === consume) {
                return true;
            }
        }
        return false;
    }


    /**
     * 
     * 
     * @param resId Resource Id (GUID)
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public accessDipDeleteById(resId: string, observe?: 'body', reportProgress?: boolean): Observable<DipModel>;
    public accessDipDeleteById(resId: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<DipModel>>;
    public accessDipDeleteById(resId: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<DipModel>>;
    public accessDipDeleteById(resId: string, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (resId === null || resId === undefined) {
            throw new Error('Required parameter resId was null or undefined when calling accessDipDeleteById.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
            'application/hal+json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected !== undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
        ];

        return this.httpClient.delete<DipModel>(`${this.configuration.basePath}/access/dip/${encodeURIComponent(String(resId))}`,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * 
     * @param size The page size
     * @param page The current page number
     * @param sort To sort on a field. By default, the sort is ascending. desc option \&#39;[,desc]\&#39; permits to have descending order.
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public accessDipGet(size?: number, page?: number, sort?: string, observe?: 'body', reportProgress?: boolean): Observable<CollectionModel>;
    public accessDipGet(size?: number, page?: number, sort?: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<CollectionModel>>;
    public accessDipGet(size?: number, page?: number, sort?: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<CollectionModel>>;
    public accessDipGet(size?: number, page?: number, sort?: string, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        let queryParameters = new HttpParams({encoder: new CustomHttpUrlEncodingCodec()});
        if (size !== undefined && size !== null) {
            queryParameters = queryParameters.set('size', <any>size);
        }
        if (page !== undefined && page !== null) {
            queryParameters = queryParameters.set('page', <any>page);
        }
        if (sort !== undefined && sort !== null) {
            queryParameters = queryParameters.set('sort', <any>sort);
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
            'application/hal+json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected !== undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
        ];

        return this.httpClient.get<CollectionModel>(`${this.configuration.basePath}/access/dip`,
            {
                params: queryParameters,
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * 
     * @param resId Resource Id (GUID)
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public accessDipGetById(resId: string, observe?: 'body', reportProgress?: boolean): Observable<DipModel>;
    public accessDipGetById(resId: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<DipModel>>;
    public accessDipGetById(resId: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<DipModel>>;
    public accessDipGetById(resId: string, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (resId === null || resId === undefined) {
            throw new Error('Required parameter resId was null or undefined when calling accessDipGetById.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
            'application/hal+json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected !== undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
        ];

        return this.httpClient.get<DipModel>(`${this.configuration.basePath}/access/dip/${encodeURIComponent(String(resId))}`,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * 
     * @param resId Resource Id (GUID)
     * @param body 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public accessDipPatchById(resId: string, body?: object, observe?: 'body', reportProgress?: boolean): Observable<DipModel>;
    public accessDipPatchById(resId: string, body?: object, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<DipModel>>;
    public accessDipPatchById(resId: string, body?: object, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<DipModel>>;
    public accessDipPatchById(resId: string, body?: object, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (resId === null || resId === undefined) {
            throw new Error('Required parameter resId was null or undefined when calling accessDipPatchById.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
            'application/hal+json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected !== undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
            'application/json'
        ];
        const httpContentTypeSelected: string | undefined = this.configuration.selectHeaderContentType(consumes);
        if (httpContentTypeSelected !== undefined) {
            headers = headers.set('Content-Type', httpContentTypeSelected);
        }

        return this.httpClient.patch<DipModel>(`${this.configuration.basePath}/access/dip/${encodeURIComponent(String(resId))}`,
            body,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * 
     * @param body 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public accessDipPost(body?: object, observe?: 'body', reportProgress?: boolean): Observable<DipModel>;
    public accessDipPost(body?: object, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<DipModel>>;
    public accessDipPost(body?: object, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<DipModel>>;
    public accessDipPost(body?: object, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        let headers = this.defaultHeaders;

        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
            'application/hal+json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected !== undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
            'application/json'
        ];
        const httpContentTypeSelected: string | undefined = this.configuration.selectHeaderContentType(consumes);
        if (httpContentTypeSelected !== undefined) {
            headers = headers.set('Content-Type', httpContentTypeSelected);
        }

        return this.httpClient.post<DipModel>(`${this.configuration.basePath}/access/dip`,
            body,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public accessGet(observe?: 'body', reportProgress?: boolean): Observable<DlcmAccessModel>;
    public accessGet(observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<DlcmAccessModel>>;
    public accessGet(observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<DlcmAccessModel>>;
    public accessGet(observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        let headers = this.defaultHeaders;

        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
            'application/hal+json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected !== undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
        ];

        return this.httpClient.get<DlcmAccessModel>(`${this.configuration.basePath}/access`,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public accessOaiSetsGet(observe?: 'body', reportProgress?: boolean): Observable<OaiSetsModel>;
    public accessOaiSetsGet(observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<OaiSetsModel>>;
    public accessOaiSetsGet(observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<OaiSetsModel>>;
    public accessOaiSetsGet(observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        let headers = this.defaultHeaders;

        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
            'application/hal+json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected !== undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
        ];

        return this.httpClient.get<OaiSetsModel>(`${this.configuration.basePath}/access/oai-sets`,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * 
     * @param resId Resource Id (GUID)
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public accessOrdersDeleteById(resId: string, observe?: 'body', reportProgress?: boolean): Observable<OrdersModel>;
    public accessOrdersDeleteById(resId: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<OrdersModel>>;
    public accessOrdersDeleteById(resId: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<OrdersModel>>;
    public accessOrdersDeleteById(resId: string, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (resId === null || resId === undefined) {
            throw new Error('Required parameter resId was null or undefined when calling accessOrdersDeleteById.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
            'application/hal+json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected !== undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
        ];

        return this.httpClient.delete<OrdersModel>(`${this.configuration.basePath}/access/orders/${encodeURIComponent(String(resId))}`,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * 
     * @param size The page size
     * @param page The current page number
     * @param sort To sort on a field. By default, the sort is ascending. desc option \&#39;[,desc]\&#39; permits to have descending order.
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public accessOrdersGet(size?: number, page?: number, sort?: string, observe?: 'body', reportProgress?: boolean): Observable<CollectionModel>;
    public accessOrdersGet(size?: number, page?: number, sort?: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<CollectionModel>>;
    public accessOrdersGet(size?: number, page?: number, sort?: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<CollectionModel>>;
    public accessOrdersGet(size?: number, page?: number, sort?: string, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        let queryParameters = new HttpParams({encoder: new CustomHttpUrlEncodingCodec()});
        if (size !== undefined && size !== null) {
            queryParameters = queryParameters.set('size', <any>size);
        }
        if (page !== undefined && page !== null) {
            queryParameters = queryParameters.set('page', <any>page);
        }
        if (sort !== undefined && sort !== null) {
            queryParameters = queryParameters.set('sort', <any>sort);
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
            'application/hal+json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected !== undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
        ];

        return this.httpClient.get<CollectionModel>(`${this.configuration.basePath}/access/orders`,
            {
                params: queryParameters,
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * 
     * @param resId Resource Id (GUID)
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public accessOrdersGetById(resId: string, observe?: 'body', reportProgress?: boolean): Observable<OrdersModel>;
    public accessOrdersGetById(resId: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<OrdersModel>>;
    public accessOrdersGetById(resId: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<OrdersModel>>;
    public accessOrdersGetById(resId: string, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (resId === null || resId === undefined) {
            throw new Error('Required parameter resId was null or undefined when calling accessOrdersGetById.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
            'application/hal+json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected !== undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
        ];

        return this.httpClient.get<OrdersModel>(`${this.configuration.basePath}/access/orders/${encodeURIComponent(String(resId))}`,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * 
     * @param resId Resource Id (GUID)
     * @param body 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public accessOrdersPatchById(resId: string, body?: object, observe?: 'body', reportProgress?: boolean): Observable<OrdersModel>;
    public accessOrdersPatchById(resId: string, body?: object, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<OrdersModel>>;
    public accessOrdersPatchById(resId: string, body?: object, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<OrdersModel>>;
    public accessOrdersPatchById(resId: string, body?: object, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (resId === null || resId === undefined) {
            throw new Error('Required parameter resId was null or undefined when calling accessOrdersPatchById.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
            'application/hal+json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected !== undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
            'application/json'
        ];
        const httpContentTypeSelected: string | undefined = this.configuration.selectHeaderContentType(consumes);
        if (httpContentTypeSelected !== undefined) {
            headers = headers.set('Content-Type', httpContentTypeSelected);
        }

        return this.httpClient.patch<OrdersModel>(`${this.configuration.basePath}/access/orders/${encodeURIComponent(String(resId))}`,
            body,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * 
     * @param body 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public accessOrdersPost(body?: object, observe?: 'body', reportProgress?: boolean): Observable<OrdersModel>;
    public accessOrdersPost(body?: object, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<OrdersModel>>;
    public accessOrdersPost(body?: object, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<OrdersModel>>;
    public accessOrdersPost(body?: object, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        let headers = this.defaultHeaders;

        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
            'application/hal+json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected !== undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
            'application/json'
        ];
        const httpContentTypeSelected: string | undefined = this.configuration.selectHeaderContentType(consumes);
        if (httpContentTypeSelected !== undefined) {
            headers = headers.set('Content-Type', httpContentTypeSelected);
        }

        return this.httpClient.post<OrdersModel>(`${this.configuration.basePath}/access/orders`,
            body,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * 
     * @param resId Resource Id (GUID)
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public adminFundingAgenciesDeleteById(resId: string, observe?: 'body', reportProgress?: boolean): Observable<FundingAgenciesModel>;
    public adminFundingAgenciesDeleteById(resId: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<FundingAgenciesModel>>;
    public adminFundingAgenciesDeleteById(resId: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<FundingAgenciesModel>>;
    public adminFundingAgenciesDeleteById(resId: string, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (resId === null || resId === undefined) {
            throw new Error('Required parameter resId was null or undefined when calling adminFundingAgenciesDeleteById.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
            'application/hal+json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected !== undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
        ];

        return this.httpClient.delete<FundingAgenciesModel>(`${this.configuration.basePath}/admin/funding-agencies/${encodeURIComponent(String(resId))}`,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * 
     * @param size The page size
     * @param page The current page number
     * @param sort To sort on a field. By default, the sort is ascending. desc option \&#39;[,desc]\&#39; permits to have descending order.
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public adminFundingAgenciesGet(size?: number, page?: number, sort?: string, observe?: 'body', reportProgress?: boolean): Observable<CollectionModel>;
    public adminFundingAgenciesGet(size?: number, page?: number, sort?: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<CollectionModel>>;
    public adminFundingAgenciesGet(size?: number, page?: number, sort?: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<CollectionModel>>;
    public adminFundingAgenciesGet(size?: number, page?: number, sort?: string, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        let queryParameters = new HttpParams({encoder: new CustomHttpUrlEncodingCodec()});
        if (size !== undefined && size !== null) {
            queryParameters = queryParameters.set('size', <any>size);
        }
        if (page !== undefined && page !== null) {
            queryParameters = queryParameters.set('page', <any>page);
        }
        if (sort !== undefined && sort !== null) {
            queryParameters = queryParameters.set('sort', <any>sort);
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
            'application/hal+json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected !== undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
        ];

        return this.httpClient.get<CollectionModel>(`${this.configuration.basePath}/admin/funding-agencies`,
            {
                params: queryParameters,
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * 
     * @param resId Resource Id (GUID)
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public adminFundingAgenciesGetById(resId: string, observe?: 'body', reportProgress?: boolean): Observable<FundingAgenciesModel>;
    public adminFundingAgenciesGetById(resId: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<FundingAgenciesModel>>;
    public adminFundingAgenciesGetById(resId: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<FundingAgenciesModel>>;
    public adminFundingAgenciesGetById(resId: string, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (resId === null || resId === undefined) {
            throw new Error('Required parameter resId was null or undefined when calling adminFundingAgenciesGetById.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
            'application/hal+json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected !== undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
        ];

        return this.httpClient.get<FundingAgenciesModel>(`${this.configuration.basePath}/admin/funding-agencies/${encodeURIComponent(String(resId))}`,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * 
     * @param resId Resource Id (GUID)
     * @param body 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public adminFundingAgenciesPatchById(resId: string, body?: object, observe?: 'body', reportProgress?: boolean): Observable<FundingAgenciesModel>;
    public adminFundingAgenciesPatchById(resId: string, body?: object, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<FundingAgenciesModel>>;
    public adminFundingAgenciesPatchById(resId: string, body?: object, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<FundingAgenciesModel>>;
    public adminFundingAgenciesPatchById(resId: string, body?: object, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (resId === null || resId === undefined) {
            throw new Error('Required parameter resId was null or undefined when calling adminFundingAgenciesPatchById.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
            'application/hal+json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected !== undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
            'application/json'
        ];
        const httpContentTypeSelected: string | undefined = this.configuration.selectHeaderContentType(consumes);
        if (httpContentTypeSelected !== undefined) {
            headers = headers.set('Content-Type', httpContentTypeSelected);
        }

        return this.httpClient.patch<FundingAgenciesModel>(`${this.configuration.basePath}/admin/funding-agencies/${encodeURIComponent(String(resId))}`,
            body,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * 
     * @param body 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public adminFundingAgenciesPost(body?: object, observe?: 'body', reportProgress?: boolean): Observable<FundingAgenciesModel>;
    public adminFundingAgenciesPost(body?: object, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<FundingAgenciesModel>>;
    public adminFundingAgenciesPost(body?: object, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<FundingAgenciesModel>>;
    public adminFundingAgenciesPost(body?: object, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        let headers = this.defaultHeaders;

        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
            'application/hal+json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected !== undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
            'application/json'
        ];
        const httpContentTypeSelected: string | undefined = this.configuration.selectHeaderContentType(consumes);
        if (httpContentTypeSelected !== undefined) {
            headers = headers.set('Content-Type', httpContentTypeSelected);
        }

        return this.httpClient.post<FundingAgenciesModel>(`${this.configuration.basePath}/admin/funding-agencies`,
            body,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public adminGet(observe?: 'body', reportProgress?: boolean): Observable<DlcmAdminModel>;
    public adminGet(observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<DlcmAdminModel>>;
    public adminGet(observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<DlcmAdminModel>>;
    public adminGet(observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        let headers = this.defaultHeaders;

        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
            'application/hal+json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected !== undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
        ];

        return this.httpClient.get<DlcmAdminModel>(`${this.configuration.basePath}/admin`,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * 
     * @param resId Resource Id (GUID)
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public adminInstitutionsDeleteById(resId: string, observe?: 'body', reportProgress?: boolean): Observable<InstitutionsModel>;
    public adminInstitutionsDeleteById(resId: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<InstitutionsModel>>;
    public adminInstitutionsDeleteById(resId: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<InstitutionsModel>>;
    public adminInstitutionsDeleteById(resId: string, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (resId === null || resId === undefined) {
            throw new Error('Required parameter resId was null or undefined when calling adminInstitutionsDeleteById.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
            'application/hal+json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected !== undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
        ];

        return this.httpClient.delete<InstitutionsModel>(`${this.configuration.basePath}/admin/institutions/${encodeURIComponent(String(resId))}`,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * 
     * @param size The page size
     * @param page The current page number
     * @param sort To sort on a field. By default, the sort is ascending. desc option \&#39;[,desc]\&#39; permits to have descending order.
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public adminInstitutionsGet(size?: number, page?: number, sort?: string, observe?: 'body', reportProgress?: boolean): Observable<CollectionModel>;
    public adminInstitutionsGet(size?: number, page?: number, sort?: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<CollectionModel>>;
    public adminInstitutionsGet(size?: number, page?: number, sort?: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<CollectionModel>>;
    public adminInstitutionsGet(size?: number, page?: number, sort?: string, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        let queryParameters = new HttpParams({encoder: new CustomHttpUrlEncodingCodec()});
        if (size !== undefined && size !== null) {
            queryParameters = queryParameters.set('size', <any>size);
        }
        if (page !== undefined && page !== null) {
            queryParameters = queryParameters.set('page', <any>page);
        }
        if (sort !== undefined && sort !== null) {
            queryParameters = queryParameters.set('sort', <any>sort);
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
            'application/hal+json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected !== undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
        ];

        return this.httpClient.get<CollectionModel>(`${this.configuration.basePath}/admin/institutions`,
            {
                params: queryParameters,
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * 
     * @param resId Resource Id (GUID)
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public adminInstitutionsGetById(resId: string, observe?: 'body', reportProgress?: boolean): Observable<InstitutionsModel>;
    public adminInstitutionsGetById(resId: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<InstitutionsModel>>;
    public adminInstitutionsGetById(resId: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<InstitutionsModel>>;
    public adminInstitutionsGetById(resId: string, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (resId === null || resId === undefined) {
            throw new Error('Required parameter resId was null or undefined when calling adminInstitutionsGetById.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
            'application/hal+json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected !== undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
        ];

        return this.httpClient.get<InstitutionsModel>(`${this.configuration.basePath}/admin/institutions/${encodeURIComponent(String(resId))}`,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * 
     * @param resId Resource Id (GUID)
     * @param body 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public adminInstitutionsPatchById(resId: string, body?: object, observe?: 'body', reportProgress?: boolean): Observable<InstitutionsModel>;
    public adminInstitutionsPatchById(resId: string, body?: object, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<InstitutionsModel>>;
    public adminInstitutionsPatchById(resId: string, body?: object, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<InstitutionsModel>>;
    public adminInstitutionsPatchById(resId: string, body?: object, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (resId === null || resId === undefined) {
            throw new Error('Required parameter resId was null or undefined when calling adminInstitutionsPatchById.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
            'application/hal+json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected !== undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
            'application/json'
        ];
        const httpContentTypeSelected: string | undefined = this.configuration.selectHeaderContentType(consumes);
        if (httpContentTypeSelected !== undefined) {
            headers = headers.set('Content-Type', httpContentTypeSelected);
        }

        return this.httpClient.patch<InstitutionsModel>(`${this.configuration.basePath}/admin/institutions/${encodeURIComponent(String(resId))}`,
            body,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * 
     * @param body 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public adminInstitutionsPost(body?: object, observe?: 'body', reportProgress?: boolean): Observable<InstitutionsModel>;
    public adminInstitutionsPost(body?: object, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<InstitutionsModel>>;
    public adminInstitutionsPost(body?: object, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<InstitutionsModel>>;
    public adminInstitutionsPost(body?: object, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        let headers = this.defaultHeaders;

        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
            'application/hal+json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected !== undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
            'application/json'
        ];
        const httpContentTypeSelected: string | undefined = this.configuration.selectHeaderContentType(consumes);
        if (httpContentTypeSelected !== undefined) {
            headers = headers.set('Content-Type', httpContentTypeSelected);
        }

        return this.httpClient.post<InstitutionsModel>(`${this.configuration.basePath}/admin/institutions`,
            body,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * 
     * @param resId Resource Id (GUID)
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public adminLanguagesDeleteById(resId: string, observe?: 'body', reportProgress?: boolean): Observable<LanguagesModel>;
    public adminLanguagesDeleteById(resId: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<LanguagesModel>>;
    public adminLanguagesDeleteById(resId: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<LanguagesModel>>;
    public adminLanguagesDeleteById(resId: string, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (resId === null || resId === undefined) {
            throw new Error('Required parameter resId was null or undefined when calling adminLanguagesDeleteById.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
            'application/hal+json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected !== undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
        ];

        return this.httpClient.delete<LanguagesModel>(`${this.configuration.basePath}/admin/languages/${encodeURIComponent(String(resId))}`,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * 
     * @param size The page size
     * @param page The current page number
     * @param sort To sort on a field. By default, the sort is ascending. desc option \&#39;[,desc]\&#39; permits to have descending order.
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public adminLanguagesGet(size?: number, page?: number, sort?: string, observe?: 'body', reportProgress?: boolean): Observable<CollectionModel>;
    public adminLanguagesGet(size?: number, page?: number, sort?: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<CollectionModel>>;
    public adminLanguagesGet(size?: number, page?: number, sort?: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<CollectionModel>>;
    public adminLanguagesGet(size?: number, page?: number, sort?: string, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        let queryParameters = new HttpParams({encoder: new CustomHttpUrlEncodingCodec()});
        if (size !== undefined && size !== null) {
            queryParameters = queryParameters.set('size', <any>size);
        }
        if (page !== undefined && page !== null) {
            queryParameters = queryParameters.set('page', <any>page);
        }
        if (sort !== undefined && sort !== null) {
            queryParameters = queryParameters.set('sort', <any>sort);
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
            'application/hal+json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected !== undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
        ];

        return this.httpClient.get<CollectionModel>(`${this.configuration.basePath}/admin/languages`,
            {
                params: queryParameters,
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * 
     * @param resId Resource Id (GUID)
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public adminLanguagesGetById(resId: string, observe?: 'body', reportProgress?: boolean): Observable<LanguagesModel>;
    public adminLanguagesGetById(resId: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<LanguagesModel>>;
    public adminLanguagesGetById(resId: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<LanguagesModel>>;
    public adminLanguagesGetById(resId: string, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (resId === null || resId === undefined) {
            throw new Error('Required parameter resId was null or undefined when calling adminLanguagesGetById.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
            'application/hal+json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected !== undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
        ];

        return this.httpClient.get<LanguagesModel>(`${this.configuration.basePath}/admin/languages/${encodeURIComponent(String(resId))}`,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * 
     * @param resId Resource Id (GUID)
     * @param body 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public adminLanguagesPatchById(resId: string, body?: object, observe?: 'body', reportProgress?: boolean): Observable<LanguagesModel>;
    public adminLanguagesPatchById(resId: string, body?: object, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<LanguagesModel>>;
    public adminLanguagesPatchById(resId: string, body?: object, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<LanguagesModel>>;
    public adminLanguagesPatchById(resId: string, body?: object, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (resId === null || resId === undefined) {
            throw new Error('Required parameter resId was null or undefined when calling adminLanguagesPatchById.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
            'application/hal+json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected !== undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
            'application/json'
        ];
        const httpContentTypeSelected: string | undefined = this.configuration.selectHeaderContentType(consumes);
        if (httpContentTypeSelected !== undefined) {
            headers = headers.set('Content-Type', httpContentTypeSelected);
        }

        return this.httpClient.patch<LanguagesModel>(`${this.configuration.basePath}/admin/languages/${encodeURIComponent(String(resId))}`,
            body,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * 
     * @param body 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public adminLanguagesPost(body?: object, observe?: 'body', reportProgress?: boolean): Observable<LanguagesModel>;
    public adminLanguagesPost(body?: object, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<LanguagesModel>>;
    public adminLanguagesPost(body?: object, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<LanguagesModel>>;
    public adminLanguagesPost(body?: object, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        let headers = this.defaultHeaders;

        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
            'application/hal+json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected !== undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
            'application/json'
        ];
        const httpContentTypeSelected: string | undefined = this.configuration.selectHeaderContentType(consumes);
        if (httpContentTypeSelected !== undefined) {
            headers = headers.set('Content-Type', httpContentTypeSelected);
        }

        return this.httpClient.post<LanguagesModel>(`${this.configuration.basePath}/admin/languages`,
            body,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * 
     * @param resId Resource Id (GUID)
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public adminLicensesDeleteById(resId: string, observe?: 'body', reportProgress?: boolean): Observable<LicensesModel>;
    public adminLicensesDeleteById(resId: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<LicensesModel>>;
    public adminLicensesDeleteById(resId: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<LicensesModel>>;
    public adminLicensesDeleteById(resId: string, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (resId === null || resId === undefined) {
            throw new Error('Required parameter resId was null or undefined when calling adminLicensesDeleteById.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
            'application/hal+json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected !== undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
        ];

        return this.httpClient.delete<LicensesModel>(`${this.configuration.basePath}/admin/licenses/${encodeURIComponent(String(resId))}`,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * 
     * @param size The page size
     * @param page The current page number
     * @param sort To sort on a field. By default, the sort is ascending. desc option \&#39;[,desc]\&#39; permits to have descending order.
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public adminLicensesGet(size?: number, page?: number, sort?: string, observe?: 'body', reportProgress?: boolean): Observable<CollectionModel>;
    public adminLicensesGet(size?: number, page?: number, sort?: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<CollectionModel>>;
    public adminLicensesGet(size?: number, page?: number, sort?: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<CollectionModel>>;
    public adminLicensesGet(size?: number, page?: number, sort?: string, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        let queryParameters = new HttpParams({encoder: new CustomHttpUrlEncodingCodec()});
        if (size !== undefined && size !== null) {
            queryParameters = queryParameters.set('size', <any>size);
        }
        if (page !== undefined && page !== null) {
            queryParameters = queryParameters.set('page', <any>page);
        }
        if (sort !== undefined && sort !== null) {
            queryParameters = queryParameters.set('sort', <any>sort);
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
            'application/hal+json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected !== undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
        ];

        return this.httpClient.get<CollectionModel>(`${this.configuration.basePath}/admin/licenses`,
            {
                params: queryParameters,
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * 
     * @param resId Resource Id (GUID)
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public adminLicensesGetById(resId: string, observe?: 'body', reportProgress?: boolean): Observable<LicensesModel>;
    public adminLicensesGetById(resId: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<LicensesModel>>;
    public adminLicensesGetById(resId: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<LicensesModel>>;
    public adminLicensesGetById(resId: string, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (resId === null || resId === undefined) {
            throw new Error('Required parameter resId was null or undefined when calling adminLicensesGetById.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
            'application/hal+json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected !== undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
        ];

        return this.httpClient.get<LicensesModel>(`${this.configuration.basePath}/admin/licenses/${encodeURIComponent(String(resId))}`,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * 
     * @param resId Resource Id (GUID)
     * @param body 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public adminLicensesPatchById(resId: string, body?: object, observe?: 'body', reportProgress?: boolean): Observable<LicensesModel>;
    public adminLicensesPatchById(resId: string, body?: object, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<LicensesModel>>;
    public adminLicensesPatchById(resId: string, body?: object, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<LicensesModel>>;
    public adminLicensesPatchById(resId: string, body?: object, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (resId === null || resId === undefined) {
            throw new Error('Required parameter resId was null or undefined when calling adminLicensesPatchById.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
            'application/hal+json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected !== undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
            'application/json'
        ];
        const httpContentTypeSelected: string | undefined = this.configuration.selectHeaderContentType(consumes);
        if (httpContentTypeSelected !== undefined) {
            headers = headers.set('Content-Type', httpContentTypeSelected);
        }

        return this.httpClient.patch<LicensesModel>(`${this.configuration.basePath}/admin/licenses/${encodeURIComponent(String(resId))}`,
            body,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * 
     * @param body 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public adminLicensesPost(body?: object, observe?: 'body', reportProgress?: boolean): Observable<LicensesModel>;
    public adminLicensesPost(body?: object, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<LicensesModel>>;
    public adminLicensesPost(body?: object, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<LicensesModel>>;
    public adminLicensesPost(body?: object, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        let headers = this.defaultHeaders;

        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
            'application/hal+json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected !== undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
            'application/json'
        ];
        const httpContentTypeSelected: string | undefined = this.configuration.selectHeaderContentType(consumes);
        if (httpContentTypeSelected !== undefined) {
            headers = headers.set('Content-Type', httpContentTypeSelected);
        }

        return this.httpClient.post<LicensesModel>(`${this.configuration.basePath}/admin/licenses`,
            body,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * 
     * @param resId Resource Id (GUID)
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public adminOauth2ClientsDeleteById(resId: string, observe?: 'body', reportProgress?: boolean): Observable<Oauth2ClientsModel>;
    public adminOauth2ClientsDeleteById(resId: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<Oauth2ClientsModel>>;
    public adminOauth2ClientsDeleteById(resId: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<Oauth2ClientsModel>>;
    public adminOauth2ClientsDeleteById(resId: string, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (resId === null || resId === undefined) {
            throw new Error('Required parameter resId was null or undefined when calling adminOauth2ClientsDeleteById.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
            'application/hal+json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected !== undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
        ];

        return this.httpClient.delete<Oauth2ClientsModel>(`${this.configuration.basePath}/admin/oauth2-clients/${encodeURIComponent(String(resId))}`,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * 
     * @param size The page size
     * @param page The current page number
     * @param sort To sort on a field. By default, the sort is ascending. desc option \&#39;[,desc]\&#39; permits to have descending order.
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public adminOauth2ClientsGet(size?: number, page?: number, sort?: string, observe?: 'body', reportProgress?: boolean): Observable<CollectionModel>;
    public adminOauth2ClientsGet(size?: number, page?: number, sort?: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<CollectionModel>>;
    public adminOauth2ClientsGet(size?: number, page?: number, sort?: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<CollectionModel>>;
    public adminOauth2ClientsGet(size?: number, page?: number, sort?: string, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        let queryParameters = new HttpParams({encoder: new CustomHttpUrlEncodingCodec()});
        if (size !== undefined && size !== null) {
            queryParameters = queryParameters.set('size', <any>size);
        }
        if (page !== undefined && page !== null) {
            queryParameters = queryParameters.set('page', <any>page);
        }
        if (sort !== undefined && sort !== null) {
            queryParameters = queryParameters.set('sort', <any>sort);
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
            'application/hal+json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected !== undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
        ];

        return this.httpClient.get<CollectionModel>(`${this.configuration.basePath}/admin/oauth2-clients`,
            {
                params: queryParameters,
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * 
     * @param resId Resource Id (GUID)
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public adminOauth2ClientsGetById(resId: string, observe?: 'body', reportProgress?: boolean): Observable<Oauth2ClientsModel>;
    public adminOauth2ClientsGetById(resId: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<Oauth2ClientsModel>>;
    public adminOauth2ClientsGetById(resId: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<Oauth2ClientsModel>>;
    public adminOauth2ClientsGetById(resId: string, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (resId === null || resId === undefined) {
            throw new Error('Required parameter resId was null or undefined when calling adminOauth2ClientsGetById.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
            'application/hal+json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected !== undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
        ];

        return this.httpClient.get<Oauth2ClientsModel>(`${this.configuration.basePath}/admin/oauth2-clients/${encodeURIComponent(String(resId))}`,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * 
     * @param resId Resource Id (GUID)
     * @param body 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public adminOauth2ClientsPatchById(resId: string, body?: object, observe?: 'body', reportProgress?: boolean): Observable<Oauth2ClientsModel>;
    public adminOauth2ClientsPatchById(resId: string, body?: object, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<Oauth2ClientsModel>>;
    public adminOauth2ClientsPatchById(resId: string, body?: object, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<Oauth2ClientsModel>>;
    public adminOauth2ClientsPatchById(resId: string, body?: object, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (resId === null || resId === undefined) {
            throw new Error('Required parameter resId was null or undefined when calling adminOauth2ClientsPatchById.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
            'application/hal+json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected !== undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
            'application/json'
        ];
        const httpContentTypeSelected: string | undefined = this.configuration.selectHeaderContentType(consumes);
        if (httpContentTypeSelected !== undefined) {
            headers = headers.set('Content-Type', httpContentTypeSelected);
        }

        return this.httpClient.patch<Oauth2ClientsModel>(`${this.configuration.basePath}/admin/oauth2-clients/${encodeURIComponent(String(resId))}`,
            body,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * 
     * @param body 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public adminOauth2ClientsPost(body?: object, observe?: 'body', reportProgress?: boolean): Observable<Oauth2ClientsModel>;
    public adminOauth2ClientsPost(body?: object, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<Oauth2ClientsModel>>;
    public adminOauth2ClientsPost(body?: object, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<Oauth2ClientsModel>>;
    public adminOauth2ClientsPost(body?: object, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        let headers = this.defaultHeaders;

        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
            'application/hal+json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected !== undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
            'application/json'
        ];
        const httpContentTypeSelected: string | undefined = this.configuration.selectHeaderContentType(consumes);
        if (httpContentTypeSelected !== undefined) {
            headers = headers.set('Content-Type', httpContentTypeSelected);
        }

        return this.httpClient.post<Oauth2ClientsModel>(`${this.configuration.basePath}/admin/oauth2-clients`,
            body,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * 
     * @param resId Resource Id (GUID)
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public adminOrganizationalUnitsDeleteById(resId: string, observe?: 'body', reportProgress?: boolean): Observable<OrganizationalUnitsModel>;
    public adminOrganizationalUnitsDeleteById(resId: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<OrganizationalUnitsModel>>;
    public adminOrganizationalUnitsDeleteById(resId: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<OrganizationalUnitsModel>>;
    public adminOrganizationalUnitsDeleteById(resId: string, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (resId === null || resId === undefined) {
            throw new Error('Required parameter resId was null or undefined when calling adminOrganizationalUnitsDeleteById.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
            'application/hal+json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected !== undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
        ];

        return this.httpClient.delete<OrganizationalUnitsModel>(`${this.configuration.basePath}/admin/organizational-units/${encodeURIComponent(String(resId))}`,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * 
     * @param size The page size
     * @param page The current page number
     * @param sort To sort on a field. By default, the sort is ascending. desc option \&#39;[,desc]\&#39; permits to have descending order.
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public adminOrganizationalUnitsGet(size?: number, page?: number, sort?: string, observe?: 'body', reportProgress?: boolean): Observable<CollectionModel>;
    public adminOrganizationalUnitsGet(size?: number, page?: number, sort?: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<CollectionModel>>;
    public adminOrganizationalUnitsGet(size?: number, page?: number, sort?: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<CollectionModel>>;
    public adminOrganizationalUnitsGet(size?: number, page?: number, sort?: string, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        let queryParameters = new HttpParams({encoder: new CustomHttpUrlEncodingCodec()});
        if (size !== undefined && size !== null) {
            queryParameters = queryParameters.set('size', <any>size);
        }
        if (page !== undefined && page !== null) {
            queryParameters = queryParameters.set('page', <any>page);
        }
        if (sort !== undefined && sort !== null) {
            queryParameters = queryParameters.set('sort', <any>sort);
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
            'application/hal+json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected !== undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
        ];

        return this.httpClient.get<CollectionModel>(`${this.configuration.basePath}/admin/organizational-units`,
            {
                params: queryParameters,
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * 
     * @param resId Resource Id (GUID)
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public adminOrganizationalUnitsGetById(resId: string, observe?: 'body', reportProgress?: boolean): Observable<OrganizationalUnitsModel>;
    public adminOrganizationalUnitsGetById(resId: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<OrganizationalUnitsModel>>;
    public adminOrganizationalUnitsGetById(resId: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<OrganizationalUnitsModel>>;
    public adminOrganizationalUnitsGetById(resId: string, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (resId === null || resId === undefined) {
            throw new Error('Required parameter resId was null or undefined when calling adminOrganizationalUnitsGetById.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
            'application/hal+json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected !== undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
        ];

        return this.httpClient.get<OrganizationalUnitsModel>(`${this.configuration.basePath}/admin/organizational-units/${encodeURIComponent(String(resId))}`,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * 
     * @param resId Resource Id (GUID)
     * @param body 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public adminOrganizationalUnitsPatchById(resId: string, body?: object, observe?: 'body', reportProgress?: boolean): Observable<OrganizationalUnitsModel>;
    public adminOrganizationalUnitsPatchById(resId: string, body?: object, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<OrganizationalUnitsModel>>;
    public adminOrganizationalUnitsPatchById(resId: string, body?: object, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<OrganizationalUnitsModel>>;
    public adminOrganizationalUnitsPatchById(resId: string, body?: object, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (resId === null || resId === undefined) {
            throw new Error('Required parameter resId was null or undefined when calling adminOrganizationalUnitsPatchById.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
            'application/hal+json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected !== undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
            'application/json'
        ];
        const httpContentTypeSelected: string | undefined = this.configuration.selectHeaderContentType(consumes);
        if (httpContentTypeSelected !== undefined) {
            headers = headers.set('Content-Type', httpContentTypeSelected);
        }

        return this.httpClient.patch<OrganizationalUnitsModel>(`${this.configuration.basePath}/admin/organizational-units/${encodeURIComponent(String(resId))}`,
            body,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * 
     * @param body 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public adminOrganizationalUnitsPost(body?: object, observe?: 'body', reportProgress?: boolean): Observable<OrganizationalUnitsModel>;
    public adminOrganizationalUnitsPost(body?: object, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<OrganizationalUnitsModel>>;
    public adminOrganizationalUnitsPost(body?: object, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<OrganizationalUnitsModel>>;
    public adminOrganizationalUnitsPost(body?: object, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        let headers = this.defaultHeaders;

        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
            'application/hal+json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected !== undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
            'application/json'
        ];
        const httpContentTypeSelected: string | undefined = this.configuration.selectHeaderContentType(consumes);
        if (httpContentTypeSelected !== undefined) {
            headers = headers.set('Content-Type', httpContentTypeSelected);
        }

        return this.httpClient.post<OrganizationalUnitsModel>(`${this.configuration.basePath}/admin/organizational-units`,
            body,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * 
     * @param resId Resource Id (GUID)
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public adminPeopleDeleteById(resId: string, observe?: 'body', reportProgress?: boolean): Observable<PeopleModel>;
    public adminPeopleDeleteById(resId: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<PeopleModel>>;
    public adminPeopleDeleteById(resId: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<PeopleModel>>;
    public adminPeopleDeleteById(resId: string, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (resId === null || resId === undefined) {
            throw new Error('Required parameter resId was null or undefined when calling adminPeopleDeleteById.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
            'application/hal+json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected !== undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
        ];

        return this.httpClient.delete<PeopleModel>(`${this.configuration.basePath}/admin/people/${encodeURIComponent(String(resId))}`,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * 
     * @param size The page size
     * @param page The current page number
     * @param sort To sort on a field. By default, the sort is ascending. desc option \&#39;[,desc]\&#39; permits to have descending order.
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public adminPeopleGet(size?: number, page?: number, sort?: string, observe?: 'body', reportProgress?: boolean): Observable<CollectionModel>;
    public adminPeopleGet(size?: number, page?: number, sort?: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<CollectionModel>>;
    public adminPeopleGet(size?: number, page?: number, sort?: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<CollectionModel>>;
    public adminPeopleGet(size?: number, page?: number, sort?: string, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        let queryParameters = new HttpParams({encoder: new CustomHttpUrlEncodingCodec()});
        if (size !== undefined && size !== null) {
            queryParameters = queryParameters.set('size', <any>size);
        }
        if (page !== undefined && page !== null) {
            queryParameters = queryParameters.set('page', <any>page);
        }
        if (sort !== undefined && sort !== null) {
            queryParameters = queryParameters.set('sort', <any>sort);
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
            'application/hal+json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected !== undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
        ];

        return this.httpClient.get<CollectionModel>(`${this.configuration.basePath}/admin/people`,
            {
                params: queryParameters,
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * 
     * @param resId Resource Id (GUID)
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public adminPeopleGetById(resId: string, observe?: 'body', reportProgress?: boolean): Observable<PeopleModel>;
    public adminPeopleGetById(resId: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<PeopleModel>>;
    public adminPeopleGetById(resId: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<PeopleModel>>;
    public adminPeopleGetById(resId: string, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (resId === null || resId === undefined) {
            throw new Error('Required parameter resId was null or undefined when calling adminPeopleGetById.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
            'application/hal+json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected !== undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
        ];

        return this.httpClient.get<PeopleModel>(`${this.configuration.basePath}/admin/people/${encodeURIComponent(String(resId))}`,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * 
     * @param resId Resource Id (GUID)
     * @param body 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public adminPeoplePatchById(resId: string, body?: object, observe?: 'body', reportProgress?: boolean): Observable<PeopleModel>;
    public adminPeoplePatchById(resId: string, body?: object, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<PeopleModel>>;
    public adminPeoplePatchById(resId: string, body?: object, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<PeopleModel>>;
    public adminPeoplePatchById(resId: string, body?: object, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (resId === null || resId === undefined) {
            throw new Error('Required parameter resId was null or undefined when calling adminPeoplePatchById.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
            'application/hal+json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected !== undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
            'application/json'
        ];
        const httpContentTypeSelected: string | undefined = this.configuration.selectHeaderContentType(consumes);
        if (httpContentTypeSelected !== undefined) {
            headers = headers.set('Content-Type', httpContentTypeSelected);
        }

        return this.httpClient.patch<PeopleModel>(`${this.configuration.basePath}/admin/people/${encodeURIComponent(String(resId))}`,
            body,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * 
     * @param body 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public adminPeoplePost(body?: object, observe?: 'body', reportProgress?: boolean): Observable<PeopleModel>;
    public adminPeoplePost(body?: object, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<PeopleModel>>;
    public adminPeoplePost(body?: object, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<PeopleModel>>;
    public adminPeoplePost(body?: object, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        let headers = this.defaultHeaders;

        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
            'application/hal+json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected !== undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
            'application/json'
        ];
        const httpContentTypeSelected: string | undefined = this.configuration.selectHeaderContentType(consumes);
        if (httpContentTypeSelected !== undefined) {
            headers = headers.set('Content-Type', httpContentTypeSelected);
        }

        return this.httpClient.post<PeopleModel>(`${this.configuration.basePath}/admin/people`,
            body,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * 
     * @param resId Resource Id (GUID)
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public adminPreservationPoliciesDeleteById(resId: string, observe?: 'body', reportProgress?: boolean): Observable<PreservationPoliciesModel>;
    public adminPreservationPoliciesDeleteById(resId: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<PreservationPoliciesModel>>;
    public adminPreservationPoliciesDeleteById(resId: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<PreservationPoliciesModel>>;
    public adminPreservationPoliciesDeleteById(resId: string, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (resId === null || resId === undefined) {
            throw new Error('Required parameter resId was null or undefined when calling adminPreservationPoliciesDeleteById.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
            'application/hal+json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected !== undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
        ];

        return this.httpClient.delete<PreservationPoliciesModel>(`${this.configuration.basePath}/admin/preservation-policies/${encodeURIComponent(String(resId))}`,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * 
     * @param size The page size
     * @param page The current page number
     * @param sort To sort on a field. By default, the sort is ascending. desc option \&#39;[,desc]\&#39; permits to have descending order.
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public adminPreservationPoliciesGet(size?: number, page?: number, sort?: string, observe?: 'body', reportProgress?: boolean): Observable<CollectionModel>;
    public adminPreservationPoliciesGet(size?: number, page?: number, sort?: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<CollectionModel>>;
    public adminPreservationPoliciesGet(size?: number, page?: number, sort?: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<CollectionModel>>;
    public adminPreservationPoliciesGet(size?: number, page?: number, sort?: string, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        let queryParameters = new HttpParams({encoder: new CustomHttpUrlEncodingCodec()});
        if (size !== undefined && size !== null) {
            queryParameters = queryParameters.set('size', <any>size);
        }
        if (page !== undefined && page !== null) {
            queryParameters = queryParameters.set('page', <any>page);
        }
        if (sort !== undefined && sort !== null) {
            queryParameters = queryParameters.set('sort', <any>sort);
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
            'application/hal+json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected !== undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
        ];

        return this.httpClient.get<CollectionModel>(`${this.configuration.basePath}/admin/preservation-policies`,
            {
                params: queryParameters,
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * 
     * @param resId Resource Id (GUID)
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public adminPreservationPoliciesGetById(resId: string, observe?: 'body', reportProgress?: boolean): Observable<PreservationPoliciesModel>;
    public adminPreservationPoliciesGetById(resId: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<PreservationPoliciesModel>>;
    public adminPreservationPoliciesGetById(resId: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<PreservationPoliciesModel>>;
    public adminPreservationPoliciesGetById(resId: string, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (resId === null || resId === undefined) {
            throw new Error('Required parameter resId was null or undefined when calling adminPreservationPoliciesGetById.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
            'application/hal+json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected !== undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
        ];

        return this.httpClient.get<PreservationPoliciesModel>(`${this.configuration.basePath}/admin/preservation-policies/${encodeURIComponent(String(resId))}`,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * 
     * @param resId Resource Id (GUID)
     * @param body 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public adminPreservationPoliciesPatchById(resId: string, body?: object, observe?: 'body', reportProgress?: boolean): Observable<PreservationPoliciesModel>;
    public adminPreservationPoliciesPatchById(resId: string, body?: object, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<PreservationPoliciesModel>>;
    public adminPreservationPoliciesPatchById(resId: string, body?: object, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<PreservationPoliciesModel>>;
    public adminPreservationPoliciesPatchById(resId: string, body?: object, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (resId === null || resId === undefined) {
            throw new Error('Required parameter resId was null or undefined when calling adminPreservationPoliciesPatchById.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
            'application/hal+json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected !== undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
            'application/json'
        ];
        const httpContentTypeSelected: string | undefined = this.configuration.selectHeaderContentType(consumes);
        if (httpContentTypeSelected !== undefined) {
            headers = headers.set('Content-Type', httpContentTypeSelected);
        }

        return this.httpClient.patch<PreservationPoliciesModel>(`${this.configuration.basePath}/admin/preservation-policies/${encodeURIComponent(String(resId))}`,
            body,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * 
     * @param body 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public adminPreservationPoliciesPost(body?: object, observe?: 'body', reportProgress?: boolean): Observable<PreservationPoliciesModel>;
    public adminPreservationPoliciesPost(body?: object, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<PreservationPoliciesModel>>;
    public adminPreservationPoliciesPost(body?: object, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<PreservationPoliciesModel>>;
    public adminPreservationPoliciesPost(body?: object, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        let headers = this.defaultHeaders;

        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
            'application/hal+json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected !== undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
            'application/json'
        ];
        const httpContentTypeSelected: string | undefined = this.configuration.selectHeaderContentType(consumes);
        if (httpContentTypeSelected !== undefined) {
            headers = headers.set('Content-Type', httpContentTypeSelected);
        }

        return this.httpClient.post<PreservationPoliciesModel>(`${this.configuration.basePath}/admin/preservation-policies`,
            body,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * 
     * @param resId Resource Id (GUID)
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public adminRolesDeleteById(resId: string, observe?: 'body', reportProgress?: boolean): Observable<RolesModel>;
    public adminRolesDeleteById(resId: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<RolesModel>>;
    public adminRolesDeleteById(resId: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<RolesModel>>;
    public adminRolesDeleteById(resId: string, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (resId === null || resId === undefined) {
            throw new Error('Required parameter resId was null or undefined when calling adminRolesDeleteById.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
            'application/hal+json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected !== undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
        ];

        return this.httpClient.delete<RolesModel>(`${this.configuration.basePath}/admin/roles/${encodeURIComponent(String(resId))}`,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * 
     * @param size The page size
     * @param page The current page number
     * @param sort To sort on a field. By default, the sort is ascending. desc option \&#39;[,desc]\&#39; permits to have descending order.
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public adminRolesGet(size?: number, page?: number, sort?: string, observe?: 'body', reportProgress?: boolean): Observable<CollectionModel>;
    public adminRolesGet(size?: number, page?: number, sort?: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<CollectionModel>>;
    public adminRolesGet(size?: number, page?: number, sort?: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<CollectionModel>>;
    public adminRolesGet(size?: number, page?: number, sort?: string, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        let queryParameters = new HttpParams({encoder: new CustomHttpUrlEncodingCodec()});
        if (size !== undefined && size !== null) {
            queryParameters = queryParameters.set('size', <any>size);
        }
        if (page !== undefined && page !== null) {
            queryParameters = queryParameters.set('page', <any>page);
        }
        if (sort !== undefined && sort !== null) {
            queryParameters = queryParameters.set('sort', <any>sort);
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
            'application/hal+json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected !== undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
        ];

        return this.httpClient.get<CollectionModel>(`${this.configuration.basePath}/admin/roles`,
            {
                params: queryParameters,
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * 
     * @param resId Resource Id (GUID)
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public adminRolesGetById(resId: string, observe?: 'body', reportProgress?: boolean): Observable<RolesModel>;
    public adminRolesGetById(resId: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<RolesModel>>;
    public adminRolesGetById(resId: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<RolesModel>>;
    public adminRolesGetById(resId: string, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (resId === null || resId === undefined) {
            throw new Error('Required parameter resId was null or undefined when calling adminRolesGetById.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
            'application/hal+json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected !== undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
        ];

        return this.httpClient.get<RolesModel>(`${this.configuration.basePath}/admin/roles/${encodeURIComponent(String(resId))}`,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * 
     * @param resId Resource Id (GUID)
     * @param body 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public adminRolesPatchById(resId: string, body?: object, observe?: 'body', reportProgress?: boolean): Observable<RolesModel>;
    public adminRolesPatchById(resId: string, body?: object, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<RolesModel>>;
    public adminRolesPatchById(resId: string, body?: object, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<RolesModel>>;
    public adminRolesPatchById(resId: string, body?: object, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (resId === null || resId === undefined) {
            throw new Error('Required parameter resId was null or undefined when calling adminRolesPatchById.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
            'application/hal+json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected !== undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
            'application/json'
        ];
        const httpContentTypeSelected: string | undefined = this.configuration.selectHeaderContentType(consumes);
        if (httpContentTypeSelected !== undefined) {
            headers = headers.set('Content-Type', httpContentTypeSelected);
        }

        return this.httpClient.patch<RolesModel>(`${this.configuration.basePath}/admin/roles/${encodeURIComponent(String(resId))}`,
            body,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * 
     * @param body 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public adminRolesPost(body?: object, observe?: 'body', reportProgress?: boolean): Observable<RolesModel>;
    public adminRolesPost(body?: object, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<RolesModel>>;
    public adminRolesPost(body?: object, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<RolesModel>>;
    public adminRolesPost(body?: object, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        let headers = this.defaultHeaders;

        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
            'application/hal+json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected !== undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
            'application/json'
        ];
        const httpContentTypeSelected: string | undefined = this.configuration.selectHeaderContentType(consumes);
        if (httpContentTypeSelected !== undefined) {
            headers = headers.set('Content-Type', httpContentTypeSelected);
        }

        return this.httpClient.post<RolesModel>(`${this.configuration.basePath}/admin/roles`,
            body,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * 
     * @param resId Resource Id (GUID)
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public adminSubmissionAgreementsDeleteById(resId: string, observe?: 'body', reportProgress?: boolean): Observable<SubmissionAgreementsModel>;
    public adminSubmissionAgreementsDeleteById(resId: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<SubmissionAgreementsModel>>;
    public adminSubmissionAgreementsDeleteById(resId: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<SubmissionAgreementsModel>>;
    public adminSubmissionAgreementsDeleteById(resId: string, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (resId === null || resId === undefined) {
            throw new Error('Required parameter resId was null or undefined when calling adminSubmissionAgreementsDeleteById.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
            'application/hal+json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected !== undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
        ];

        return this.httpClient.delete<SubmissionAgreementsModel>(`${this.configuration.basePath}/admin/submission-agreements/${encodeURIComponent(String(resId))}`,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * 
     * @param size The page size
     * @param page The current page number
     * @param sort To sort on a field. By default, the sort is ascending. desc option \&#39;[,desc]\&#39; permits to have descending order.
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public adminSubmissionAgreementsGet(size?: number, page?: number, sort?: string, observe?: 'body', reportProgress?: boolean): Observable<CollectionModel>;
    public adminSubmissionAgreementsGet(size?: number, page?: number, sort?: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<CollectionModel>>;
    public adminSubmissionAgreementsGet(size?: number, page?: number, sort?: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<CollectionModel>>;
    public adminSubmissionAgreementsGet(size?: number, page?: number, sort?: string, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        let queryParameters = new HttpParams({encoder: new CustomHttpUrlEncodingCodec()});
        if (size !== undefined && size !== null) {
            queryParameters = queryParameters.set('size', <any>size);
        }
        if (page !== undefined && page !== null) {
            queryParameters = queryParameters.set('page', <any>page);
        }
        if (sort !== undefined && sort !== null) {
            queryParameters = queryParameters.set('sort', <any>sort);
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
            'application/hal+json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected !== undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
        ];

        return this.httpClient.get<CollectionModel>(`${this.configuration.basePath}/admin/submission-agreements`,
            {
                params: queryParameters,
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * 
     * @param resId Resource Id (GUID)
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public adminSubmissionAgreementsGetById(resId: string, observe?: 'body', reportProgress?: boolean): Observable<SubmissionAgreementsModel>;
    public adminSubmissionAgreementsGetById(resId: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<SubmissionAgreementsModel>>;
    public adminSubmissionAgreementsGetById(resId: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<SubmissionAgreementsModel>>;
    public adminSubmissionAgreementsGetById(resId: string, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (resId === null || resId === undefined) {
            throw new Error('Required parameter resId was null or undefined when calling adminSubmissionAgreementsGetById.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
            'application/hal+json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected !== undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
        ];

        return this.httpClient.get<SubmissionAgreementsModel>(`${this.configuration.basePath}/admin/submission-agreements/${encodeURIComponent(String(resId))}`,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * 
     * @param resId Resource Id (GUID)
     * @param body 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public adminSubmissionAgreementsPatchById(resId: string, body?: object, observe?: 'body', reportProgress?: boolean): Observable<SubmissionAgreementsModel>;
    public adminSubmissionAgreementsPatchById(resId: string, body?: object, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<SubmissionAgreementsModel>>;
    public adminSubmissionAgreementsPatchById(resId: string, body?: object, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<SubmissionAgreementsModel>>;
    public adminSubmissionAgreementsPatchById(resId: string, body?: object, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (resId === null || resId === undefined) {
            throw new Error('Required parameter resId was null or undefined when calling adminSubmissionAgreementsPatchById.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
            'application/hal+json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected !== undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
            'application/json'
        ];
        const httpContentTypeSelected: string | undefined = this.configuration.selectHeaderContentType(consumes);
        if (httpContentTypeSelected !== undefined) {
            headers = headers.set('Content-Type', httpContentTypeSelected);
        }

        return this.httpClient.patch<SubmissionAgreementsModel>(`${this.configuration.basePath}/admin/submission-agreements/${encodeURIComponent(String(resId))}`,
            body,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * 
     * @param body 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public adminSubmissionAgreementsPost(body?: object, observe?: 'body', reportProgress?: boolean): Observable<SubmissionAgreementsModel>;
    public adminSubmissionAgreementsPost(body?: object, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<SubmissionAgreementsModel>>;
    public adminSubmissionAgreementsPost(body?: object, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<SubmissionAgreementsModel>>;
    public adminSubmissionAgreementsPost(body?: object, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        let headers = this.defaultHeaders;

        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
            'application/hal+json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected !== undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
            'application/json'
        ];
        const httpContentTypeSelected: string | undefined = this.configuration.selectHeaderContentType(consumes);
        if (httpContentTypeSelected !== undefined) {
            headers = headers.set('Content-Type', httpContentTypeSelected);
        }

        return this.httpClient.post<SubmissionAgreementsModel>(`${this.configuration.basePath}/admin/submission-agreements`,
            body,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * 
     * @param resId Resource Id (GUID)
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public adminSubmissionPoliciesDeleteById(resId: string, observe?: 'body', reportProgress?: boolean): Observable<SubmissionPoliciesModel>;
    public adminSubmissionPoliciesDeleteById(resId: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<SubmissionPoliciesModel>>;
    public adminSubmissionPoliciesDeleteById(resId: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<SubmissionPoliciesModel>>;
    public adminSubmissionPoliciesDeleteById(resId: string, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (resId === null || resId === undefined) {
            throw new Error('Required parameter resId was null or undefined when calling adminSubmissionPoliciesDeleteById.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
            'application/hal+json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected !== undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
        ];

        return this.httpClient.delete<SubmissionPoliciesModel>(`${this.configuration.basePath}/admin/submission-policies/${encodeURIComponent(String(resId))}`,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * 
     * @param size The page size
     * @param page The current page number
     * @param sort To sort on a field. By default, the sort is ascending. desc option \&#39;[,desc]\&#39; permits to have descending order.
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public adminSubmissionPoliciesGet(size?: number, page?: number, sort?: string, observe?: 'body', reportProgress?: boolean): Observable<CollectionModel>;
    public adminSubmissionPoliciesGet(size?: number, page?: number, sort?: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<CollectionModel>>;
    public adminSubmissionPoliciesGet(size?: number, page?: number, sort?: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<CollectionModel>>;
    public adminSubmissionPoliciesGet(size?: number, page?: number, sort?: string, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        let queryParameters = new HttpParams({encoder: new CustomHttpUrlEncodingCodec()});
        if (size !== undefined && size !== null) {
            queryParameters = queryParameters.set('size', <any>size);
        }
        if (page !== undefined && page !== null) {
            queryParameters = queryParameters.set('page', <any>page);
        }
        if (sort !== undefined && sort !== null) {
            queryParameters = queryParameters.set('sort', <any>sort);
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
            'application/hal+json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected !== undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
        ];

        return this.httpClient.get<CollectionModel>(`${this.configuration.basePath}/admin/submission-policies`,
            {
                params: queryParameters,
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * 
     * @param resId Resource Id (GUID)
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public adminSubmissionPoliciesGetById(resId: string, observe?: 'body', reportProgress?: boolean): Observable<SubmissionPoliciesModel>;
    public adminSubmissionPoliciesGetById(resId: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<SubmissionPoliciesModel>>;
    public adminSubmissionPoliciesGetById(resId: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<SubmissionPoliciesModel>>;
    public adminSubmissionPoliciesGetById(resId: string, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (resId === null || resId === undefined) {
            throw new Error('Required parameter resId was null or undefined when calling adminSubmissionPoliciesGetById.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
            'application/hal+json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected !== undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
        ];

        return this.httpClient.get<SubmissionPoliciesModel>(`${this.configuration.basePath}/admin/submission-policies/${encodeURIComponent(String(resId))}`,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * 
     * @param resId Resource Id (GUID)
     * @param body 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public adminSubmissionPoliciesPatchById(resId: string, body?: object, observe?: 'body', reportProgress?: boolean): Observable<SubmissionPoliciesModel>;
    public adminSubmissionPoliciesPatchById(resId: string, body?: object, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<SubmissionPoliciesModel>>;
    public adminSubmissionPoliciesPatchById(resId: string, body?: object, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<SubmissionPoliciesModel>>;
    public adminSubmissionPoliciesPatchById(resId: string, body?: object, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (resId === null || resId === undefined) {
            throw new Error('Required parameter resId was null or undefined when calling adminSubmissionPoliciesPatchById.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
            'application/hal+json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected !== undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
            'application/json'
        ];
        const httpContentTypeSelected: string | undefined = this.configuration.selectHeaderContentType(consumes);
        if (httpContentTypeSelected !== undefined) {
            headers = headers.set('Content-Type', httpContentTypeSelected);
        }

        return this.httpClient.patch<SubmissionPoliciesModel>(`${this.configuration.basePath}/admin/submission-policies/${encodeURIComponent(String(resId))}`,
            body,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * 
     * @param body 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public adminSubmissionPoliciesPost(body?: object, observe?: 'body', reportProgress?: boolean): Observable<SubmissionPoliciesModel>;
    public adminSubmissionPoliciesPost(body?: object, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<SubmissionPoliciesModel>>;
    public adminSubmissionPoliciesPost(body?: object, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<SubmissionPoliciesModel>>;
    public adminSubmissionPoliciesPost(body?: object, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        let headers = this.defaultHeaders;

        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
            'application/hal+json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected !== undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
            'application/json'
        ];
        const httpContentTypeSelected: string | undefined = this.configuration.selectHeaderContentType(consumes);
        if (httpContentTypeSelected !== undefined) {
            headers = headers.set('Content-Type', httpContentTypeSelected);
        }

        return this.httpClient.post<SubmissionPoliciesModel>(`${this.configuration.basePath}/admin/submission-policies`,
            body,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * 
     * @param resId Resource Id (GUID)
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public adminUsersDeleteById(resId: string, observe?: 'body', reportProgress?: boolean): Observable<UsersModel>;
    public adminUsersDeleteById(resId: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<UsersModel>>;
    public adminUsersDeleteById(resId: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<UsersModel>>;
    public adminUsersDeleteById(resId: string, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (resId === null || resId === undefined) {
            throw new Error('Required parameter resId was null or undefined when calling adminUsersDeleteById.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
            'application/hal+json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected !== undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
        ];

        return this.httpClient.delete<UsersModel>(`${this.configuration.basePath}/admin/users/${encodeURIComponent(String(resId))}`,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * 
     * @param size The page size
     * @param page The current page number
     * @param sort To sort on a field. By default, the sort is ascending. desc option \&#39;[,desc]\&#39; permits to have descending order.
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public adminUsersGet(size?: number, page?: number, sort?: string, observe?: 'body', reportProgress?: boolean): Observable<CollectionModel>;
    public adminUsersGet(size?: number, page?: number, sort?: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<CollectionModel>>;
    public adminUsersGet(size?: number, page?: number, sort?: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<CollectionModel>>;
    public adminUsersGet(size?: number, page?: number, sort?: string, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        let queryParameters = new HttpParams({encoder: new CustomHttpUrlEncodingCodec()});
        if (size !== undefined && size !== null) {
            queryParameters = queryParameters.set('size', <any>size);
        }
        if (page !== undefined && page !== null) {
            queryParameters = queryParameters.set('page', <any>page);
        }
        if (sort !== undefined && sort !== null) {
            queryParameters = queryParameters.set('sort', <any>sort);
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
            'application/hal+json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected !== undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
        ];

        return this.httpClient.get<CollectionModel>(`${this.configuration.basePath}/admin/users`,
            {
                params: queryParameters,
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * 
     * @param resId Resource Id (GUID)
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public adminUsersGetById(resId: string, observe?: 'body', reportProgress?: boolean): Observable<UsersModel>;
    public adminUsersGetById(resId: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<UsersModel>>;
    public adminUsersGetById(resId: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<UsersModel>>;
    public adminUsersGetById(resId: string, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (resId === null || resId === undefined) {
            throw new Error('Required parameter resId was null or undefined when calling adminUsersGetById.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
            'application/hal+json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected !== undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
        ];

        return this.httpClient.get<UsersModel>(`${this.configuration.basePath}/admin/users/${encodeURIComponent(String(resId))}`,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * 
     * @param resId Resource Id (GUID)
     * @param body 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public adminUsersPatchById(resId: string, body?: object, observe?: 'body', reportProgress?: boolean): Observable<UsersModel>;
    public adminUsersPatchById(resId: string, body?: object, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<UsersModel>>;
    public adminUsersPatchById(resId: string, body?: object, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<UsersModel>>;
    public adminUsersPatchById(resId: string, body?: object, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (resId === null || resId === undefined) {
            throw new Error('Required parameter resId was null or undefined when calling adminUsersPatchById.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
            'application/hal+json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected !== undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
            'application/json'
        ];
        const httpContentTypeSelected: string | undefined = this.configuration.selectHeaderContentType(consumes);
        if (httpContentTypeSelected !== undefined) {
            headers = headers.set('Content-Type', httpContentTypeSelected);
        }

        return this.httpClient.patch<UsersModel>(`${this.configuration.basePath}/admin/users/${encodeURIComponent(String(resId))}`,
            body,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * 
     * @param body 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public adminUsersPost(body?: object, observe?: 'body', reportProgress?: boolean): Observable<UsersModel>;
    public adminUsersPost(body?: object, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<UsersModel>>;
    public adminUsersPost(body?: object, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<UsersModel>>;
    public adminUsersPost(body?: object, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        let headers = this.defaultHeaders;

        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
            'application/hal+json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected !== undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
            'application/json'
        ];
        const httpContentTypeSelected: string | undefined = this.configuration.selectHeaderContentType(consumes);
        if (httpContentTypeSelected !== undefined) {
            headers = headers.set('Content-Type', httpContentTypeSelected);
        }

        return this.httpClient.post<UsersModel>(`${this.configuration.basePath}/admin/users`,
            body,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public applicationGet(observe?: 'body', reportProgress?: boolean): Observable<DlcmModel>;
    public applicationGet(observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<DlcmModel>>;
    public applicationGet(observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<DlcmModel>>;
    public applicationGet(observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        let headers = this.defaultHeaders;

        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
            'application/hal+json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected !== undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
        ];

        return this.httpClient.get<DlcmModel>(`${this.configuration.basePath}/`,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * 
     * @param resId Resource Id (GUID)
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public archivalStorageAipDeleteById(resId: string, observe?: 'body', reportProgress?: boolean): Observable<AipModel>;
    public archivalStorageAipDeleteById(resId: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<AipModel>>;
    public archivalStorageAipDeleteById(resId: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<AipModel>>;
    public archivalStorageAipDeleteById(resId: string, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (resId === null || resId === undefined) {
            throw new Error('Required parameter resId was null or undefined when calling archivalStorageAipDeleteById.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
            'application/hal+json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected !== undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
        ];

        return this.httpClient.delete<AipModel>(`${this.configuration.basePath}/archival-storage/aip/${encodeURIComponent(String(resId))}`,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * 
     * @param size The page size
     * @param page The current page number
     * @param sort To sort on a field. By default, the sort is ascending. desc option \&#39;[,desc]\&#39; permits to have descending order.
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public archivalStorageAipGet(size?: number, page?: number, sort?: string, observe?: 'body', reportProgress?: boolean): Observable<CollectionModel>;
    public archivalStorageAipGet(size?: number, page?: number, sort?: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<CollectionModel>>;
    public archivalStorageAipGet(size?: number, page?: number, sort?: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<CollectionModel>>;
    public archivalStorageAipGet(size?: number, page?: number, sort?: string, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        let queryParameters = new HttpParams({encoder: new CustomHttpUrlEncodingCodec()});
        if (size !== undefined && size !== null) {
            queryParameters = queryParameters.set('size', <any>size);
        }
        if (page !== undefined && page !== null) {
            queryParameters = queryParameters.set('page', <any>page);
        }
        if (sort !== undefined && sort !== null) {
            queryParameters = queryParameters.set('sort', <any>sort);
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
            'application/hal+json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected !== undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
        ];

        return this.httpClient.get<CollectionModel>(`${this.configuration.basePath}/archival-storage/aip`,
            {
                params: queryParameters,
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * 
     * @param resId Resource Id (GUID)
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public archivalStorageAipGetById(resId: string, observe?: 'body', reportProgress?: boolean): Observable<AipModel>;
    public archivalStorageAipGetById(resId: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<AipModel>>;
    public archivalStorageAipGetById(resId: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<AipModel>>;
    public archivalStorageAipGetById(resId: string, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (resId === null || resId === undefined) {
            throw new Error('Required parameter resId was null or undefined when calling archivalStorageAipGetById.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
            'application/hal+json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected !== undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
        ];

        return this.httpClient.get<AipModel>(`${this.configuration.basePath}/archival-storage/aip/${encodeURIComponent(String(resId))}`,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * 
     * @param resId Resource Id (GUID)
     * @param body 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public archivalStorageAipPatchById(resId: string, body?: object, observe?: 'body', reportProgress?: boolean): Observable<AipModel>;
    public archivalStorageAipPatchById(resId: string, body?: object, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<AipModel>>;
    public archivalStorageAipPatchById(resId: string, body?: object, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<AipModel>>;
    public archivalStorageAipPatchById(resId: string, body?: object, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (resId === null || resId === undefined) {
            throw new Error('Required parameter resId was null or undefined when calling archivalStorageAipPatchById.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
            'application/hal+json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected !== undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
            'application/json'
        ];
        const httpContentTypeSelected: string | undefined = this.configuration.selectHeaderContentType(consumes);
        if (httpContentTypeSelected !== undefined) {
            headers = headers.set('Content-Type', httpContentTypeSelected);
        }

        return this.httpClient.patch<AipModel>(`${this.configuration.basePath}/archival-storage/aip/${encodeURIComponent(String(resId))}`,
            body,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * 
     * @param body 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public archivalStorageAipPost(body?: object, observe?: 'body', reportProgress?: boolean): Observable<AipModel>;
    public archivalStorageAipPost(body?: object, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<AipModel>>;
    public archivalStorageAipPost(body?: object, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<AipModel>>;
    public archivalStorageAipPost(body?: object, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        let headers = this.defaultHeaders;

        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
            'application/hal+json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected !== undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
            'application/json'
        ];
        const httpContentTypeSelected: string | undefined = this.configuration.selectHeaderContentType(consumes);
        if (httpContentTypeSelected !== undefined) {
            headers = headers.set('Content-Type', httpContentTypeSelected);
        }

        return this.httpClient.post<AipModel>(`${this.configuration.basePath}/archival-storage/aip`,
            body,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public archivalStorageGet(observe?: 'body', reportProgress?: boolean): Observable<DlcmArchivalStorageModel>;
    public archivalStorageGet(observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<DlcmArchivalStorageModel>>;
    public archivalStorageGet(observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<DlcmArchivalStorageModel>>;
    public archivalStorageGet(observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        let headers = this.defaultHeaders;

        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
            'application/hal+json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected !== undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
        ];

        return this.httpClient.get<DlcmArchivalStorageModel>(`${this.configuration.basePath}/archival-storage`,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public archivalStorageStoredAipGet(observe?: 'body', reportProgress?: boolean): Observable<OaiSetsModel>;
    public archivalStorageStoredAipGet(observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<OaiSetsModel>>;
    public archivalStorageStoredAipGet(observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<OaiSetsModel>>;
    public archivalStorageStoredAipGet(observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        let headers = this.defaultHeaders;

        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
            'application/hal+json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected !== undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
        ];

        return this.httpClient.get<OaiSetsModel>(`${this.configuration.basePath}/archival-storage/stored-aip`,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public dataMgmtGet(observe?: 'body', reportProgress?: boolean): Observable<DlcmDataMgmtModel>;
    public dataMgmtGet(observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<DlcmDataMgmtModel>>;
    public dataMgmtGet(observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<DlcmDataMgmtModel>>;
    public dataMgmtGet(observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        let headers = this.defaultHeaders;

        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
            'application/hal+json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected !== undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
        ];

        return this.httpClient.get<DlcmDataMgmtModel>(`${this.configuration.basePath}/data-mgmt`,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public ingestGet(observe?: 'body', reportProgress?: boolean): Observable<DlcmIngestModel>;
    public ingestGet(observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<DlcmIngestModel>>;
    public ingestGet(observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<DlcmIngestModel>>;
    public ingestGet(observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        let headers = this.defaultHeaders;

        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
            'application/hal+json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected !== undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
        ];

        return this.httpClient.get<DlcmIngestModel>(`${this.configuration.basePath}/ingest`,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * 
     * @param resId Resource Id (GUID)
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public ingestSipDeleteById(resId: string, observe?: 'body', reportProgress?: boolean): Observable<SipModel>;
    public ingestSipDeleteById(resId: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<SipModel>>;
    public ingestSipDeleteById(resId: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<SipModel>>;
    public ingestSipDeleteById(resId: string, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (resId === null || resId === undefined) {
            throw new Error('Required parameter resId was null or undefined when calling ingestSipDeleteById.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
            'application/hal+json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected !== undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
        ];

        return this.httpClient.delete<SipModel>(`${this.configuration.basePath}/ingest/sip/${encodeURIComponent(String(resId))}`,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * 
     * @param size The page size
     * @param page The current page number
     * @param sort To sort on a field. By default, the sort is ascending. desc option \&#39;[,desc]\&#39; permits to have descending order.
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public ingestSipGet(size?: number, page?: number, sort?: string, observe?: 'body', reportProgress?: boolean): Observable<CollectionModel>;
    public ingestSipGet(size?: number, page?: number, sort?: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<CollectionModel>>;
    public ingestSipGet(size?: number, page?: number, sort?: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<CollectionModel>>;
    public ingestSipGet(size?: number, page?: number, sort?: string, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        let queryParameters = new HttpParams({encoder: new CustomHttpUrlEncodingCodec()});
        if (size !== undefined && size !== null) {
            queryParameters = queryParameters.set('size', <any>size);
        }
        if (page !== undefined && page !== null) {
            queryParameters = queryParameters.set('page', <any>page);
        }
        if (sort !== undefined && sort !== null) {
            queryParameters = queryParameters.set('sort', <any>sort);
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
            'application/hal+json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected !== undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
        ];

        return this.httpClient.get<CollectionModel>(`${this.configuration.basePath}/ingest/sip`,
            {
                params: queryParameters,
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * 
     * @param resId Resource Id (GUID)
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public ingestSipGetById(resId: string, observe?: 'body', reportProgress?: boolean): Observable<SipModel>;
    public ingestSipGetById(resId: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<SipModel>>;
    public ingestSipGetById(resId: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<SipModel>>;
    public ingestSipGetById(resId: string, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (resId === null || resId === undefined) {
            throw new Error('Required parameter resId was null or undefined when calling ingestSipGetById.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
            'application/hal+json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected !== undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
        ];

        return this.httpClient.get<SipModel>(`${this.configuration.basePath}/ingest/sip/${encodeURIComponent(String(resId))}`,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * 
     * @param resId Resource Id (GUID)
     * @param body 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public ingestSipPatchById(resId: string, body?: object, observe?: 'body', reportProgress?: boolean): Observable<SipModel>;
    public ingestSipPatchById(resId: string, body?: object, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<SipModel>>;
    public ingestSipPatchById(resId: string, body?: object, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<SipModel>>;
    public ingestSipPatchById(resId: string, body?: object, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (resId === null || resId === undefined) {
            throw new Error('Required parameter resId was null or undefined when calling ingestSipPatchById.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
            'application/hal+json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected !== undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
            'application/json'
        ];
        const httpContentTypeSelected: string | undefined = this.configuration.selectHeaderContentType(consumes);
        if (httpContentTypeSelected !== undefined) {
            headers = headers.set('Content-Type', httpContentTypeSelected);
        }

        return this.httpClient.patch<SipModel>(`${this.configuration.basePath}/ingest/sip/${encodeURIComponent(String(resId))}`,
            body,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * 
     * @param body 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public ingestSipPost(body?: object, observe?: 'body', reportProgress?: boolean): Observable<SipModel>;
    public ingestSipPost(body?: object, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<SipModel>>;
    public ingestSipPost(body?: object, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<SipModel>>;
    public ingestSipPost(body?: object, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        let headers = this.defaultHeaders;

        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
            'application/hal+json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected !== undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
            'application/json'
        ];
        const httpContentTypeSelected: string | undefined = this.configuration.selectHeaderContentType(consumes);
        if (httpContentTypeSelected !== undefined) {
            headers = headers.set('Content-Type', httpContentTypeSelected);
        }

        return this.httpClient.post<SipModel>(`${this.configuration.basePath}/ingest/sip`,
            body,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * 
     * @param resId Resource Id (GUID)
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public preingestDepositsDeleteById(resId: string, observe?: 'body', reportProgress?: boolean): Observable<DepositsModel>;
    public preingestDepositsDeleteById(resId: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<DepositsModel>>;
    public preingestDepositsDeleteById(resId: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<DepositsModel>>;
    public preingestDepositsDeleteById(resId: string, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (resId === null || resId === undefined) {
            throw new Error('Required parameter resId was null or undefined when calling preingestDepositsDeleteById.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
            'application/hal+json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected !== undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
        ];

        return this.httpClient.delete<DepositsModel>(`${this.configuration.basePath}/preingest/deposits/${encodeURIComponent(String(resId))}`,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * 
     * @param size The page size
     * @param page The current page number
     * @param sort To sort on a field. By default, the sort is ascending. desc option \&#39;[,desc]\&#39; permits to have descending order.
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public preingestDepositsGet(size?: number, page?: number, sort?: string, observe?: 'body', reportProgress?: boolean): Observable<CollectionModel>;
    public preingestDepositsGet(size?: number, page?: number, sort?: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<CollectionModel>>;
    public preingestDepositsGet(size?: number, page?: number, sort?: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<CollectionModel>>;
    public preingestDepositsGet(size?: number, page?: number, sort?: string, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        let queryParameters = new HttpParams({encoder: new CustomHttpUrlEncodingCodec()});
        if (size !== undefined && size !== null) {
            queryParameters = queryParameters.set('size', <any>size);
        }
        if (page !== undefined && page !== null) {
            queryParameters = queryParameters.set('page', <any>page);
        }
        if (sort !== undefined && sort !== null) {
            queryParameters = queryParameters.set('sort', <any>sort);
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
            'application/hal+json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected !== undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
        ];

        return this.httpClient.get<CollectionModel>(`${this.configuration.basePath}/preingest/deposits`,
            {
                params: queryParameters,
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * 
     * @param resId Resource Id (GUID)
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public preingestDepositsGetById(resId: string, observe?: 'body', reportProgress?: boolean): Observable<DepositsModel>;
    public preingestDepositsGetById(resId: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<DepositsModel>>;
    public preingestDepositsGetById(resId: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<DepositsModel>>;
    public preingestDepositsGetById(resId: string, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (resId === null || resId === undefined) {
            throw new Error('Required parameter resId was null or undefined when calling preingestDepositsGetById.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
            'application/hal+json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected !== undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
        ];

        return this.httpClient.get<DepositsModel>(`${this.configuration.basePath}/preingest/deposits/${encodeURIComponent(String(resId))}`,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * 
     * @param resId Resource Id (GUID)
     * @param body 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public preingestDepositsPatchById(resId: string, body?: object, observe?: 'body', reportProgress?: boolean): Observable<DepositsModel>;
    public preingestDepositsPatchById(resId: string, body?: object, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<DepositsModel>>;
    public preingestDepositsPatchById(resId: string, body?: object, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<DepositsModel>>;
    public preingestDepositsPatchById(resId: string, body?: object, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (resId === null || resId === undefined) {
            throw new Error('Required parameter resId was null or undefined when calling preingestDepositsPatchById.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
            'application/hal+json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected !== undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
            'application/json'
        ];
        const httpContentTypeSelected: string | undefined = this.configuration.selectHeaderContentType(consumes);
        if (httpContentTypeSelected !== undefined) {
            headers = headers.set('Content-Type', httpContentTypeSelected);
        }

        return this.httpClient.patch<DepositsModel>(`${this.configuration.basePath}/preingest/deposits/${encodeURIComponent(String(resId))}`,
            body,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * 
     * @param body 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public preingestDepositsPost(body?: object, observe?: 'body', reportProgress?: boolean): Observable<DepositsModel>;
    public preingestDepositsPost(body?: object, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<DepositsModel>>;
    public preingestDepositsPost(body?: object, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<DepositsModel>>;
    public preingestDepositsPost(body?: object, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        let headers = this.defaultHeaders;

        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
            'application/hal+json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected !== undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
            'application/json'
        ];
        const httpContentTypeSelected: string | undefined = this.configuration.selectHeaderContentType(consumes);
        if (httpContentTypeSelected !== undefined) {
            headers = headers.set('Content-Type', httpContentTypeSelected);
        }

        return this.httpClient.post<DepositsModel>(`${this.configuration.basePath}/preingest/deposits`,
            body,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public preingestGet(observe?: 'body', reportProgress?: boolean): Observable<DlcmPreingestModel>;
    public preingestGet(observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<DlcmPreingestModel>>;
    public preingestGet(observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<DlcmPreingestModel>>;
    public preingestGet(observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        let headers = this.defaultHeaders;

        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
            'application/hal+json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected !== undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
        ];

        return this.httpClient.get<DlcmPreingestModel>(`${this.configuration.basePath}/preingest`,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public preservationPlanningGet(observe?: 'body', reportProgress?: boolean): Observable<DlcmPreservationPlanningModel>;
    public preservationPlanningGet(observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<DlcmPreservationPlanningModel>>;
    public preservationPlanningGet(observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<DlcmPreservationPlanningModel>>;
    public preservationPlanningGet(observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        let headers = this.defaultHeaders;

        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
            'application/hal+json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected !== undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
        ];

        return this.httpClient.get<DlcmPreservationPlanningModel>(`${this.configuration.basePath}/preservation-planning`,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * 
     * @param resId Resource Id (GUID)
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public preservationPlanningPreservationJobsDeleteById(resId: string, observe?: 'body', reportProgress?: boolean): Observable<PreservationJobsModel>;
    public preservationPlanningPreservationJobsDeleteById(resId: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<PreservationJobsModel>>;
    public preservationPlanningPreservationJobsDeleteById(resId: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<PreservationJobsModel>>;
    public preservationPlanningPreservationJobsDeleteById(resId: string, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (resId === null || resId === undefined) {
            throw new Error('Required parameter resId was null or undefined when calling preservationPlanningPreservationJobsDeleteById.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
            'application/hal+json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected !== undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
        ];

        return this.httpClient.delete<PreservationJobsModel>(`${this.configuration.basePath}/preservation-planning/preservation-jobs/${encodeURIComponent(String(resId))}`,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * 
     * @param size The page size
     * @param page The current page number
     * @param sort To sort on a field. By default, the sort is ascending. desc option \&#39;[,desc]\&#39; permits to have descending order.
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public preservationPlanningPreservationJobsGet(size?: number, page?: number, sort?: string, observe?: 'body', reportProgress?: boolean): Observable<CollectionModel>;
    public preservationPlanningPreservationJobsGet(size?: number, page?: number, sort?: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<CollectionModel>>;
    public preservationPlanningPreservationJobsGet(size?: number, page?: number, sort?: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<CollectionModel>>;
    public preservationPlanningPreservationJobsGet(size?: number, page?: number, sort?: string, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        let queryParameters = new HttpParams({encoder: new CustomHttpUrlEncodingCodec()});
        if (size !== undefined && size !== null) {
            queryParameters = queryParameters.set('size', <any>size);
        }
        if (page !== undefined && page !== null) {
            queryParameters = queryParameters.set('page', <any>page);
        }
        if (sort !== undefined && sort !== null) {
            queryParameters = queryParameters.set('sort', <any>sort);
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
            'application/hal+json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected !== undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
        ];

        return this.httpClient.get<CollectionModel>(`${this.configuration.basePath}/preservation-planning/preservation-jobs`,
            {
                params: queryParameters,
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * 
     * @param resId Resource Id (GUID)
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public preservationPlanningPreservationJobsGetById(resId: string, observe?: 'body', reportProgress?: boolean): Observable<PreservationJobsModel>;
    public preservationPlanningPreservationJobsGetById(resId: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<PreservationJobsModel>>;
    public preservationPlanningPreservationJobsGetById(resId: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<PreservationJobsModel>>;
    public preservationPlanningPreservationJobsGetById(resId: string, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (resId === null || resId === undefined) {
            throw new Error('Required parameter resId was null or undefined when calling preservationPlanningPreservationJobsGetById.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
            'application/hal+json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected !== undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
        ];

        return this.httpClient.get<PreservationJobsModel>(`${this.configuration.basePath}/preservation-planning/preservation-jobs/${encodeURIComponent(String(resId))}`,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * 
     * @param resId Resource Id (GUID)
     * @param body 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public preservationPlanningPreservationJobsPatchById(resId: string, body?: object, observe?: 'body', reportProgress?: boolean): Observable<PreservationJobsModel>;
    public preservationPlanningPreservationJobsPatchById(resId: string, body?: object, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<PreservationJobsModel>>;
    public preservationPlanningPreservationJobsPatchById(resId: string, body?: object, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<PreservationJobsModel>>;
    public preservationPlanningPreservationJobsPatchById(resId: string, body?: object, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (resId === null || resId === undefined) {
            throw new Error('Required parameter resId was null or undefined when calling preservationPlanningPreservationJobsPatchById.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
            'application/hal+json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected !== undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
            'application/json'
        ];
        const httpContentTypeSelected: string | undefined = this.configuration.selectHeaderContentType(consumes);
        if (httpContentTypeSelected !== undefined) {
            headers = headers.set('Content-Type', httpContentTypeSelected);
        }

        return this.httpClient.patch<PreservationJobsModel>(`${this.configuration.basePath}/preservation-planning/preservation-jobs/${encodeURIComponent(String(resId))}`,
            body,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * 
     * @param body 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public preservationPlanningPreservationJobsPost(body?: object, observe?: 'body', reportProgress?: boolean): Observable<PreservationJobsModel>;
    public preservationPlanningPreservationJobsPost(body?: object, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<PreservationJobsModel>>;
    public preservationPlanningPreservationJobsPost(body?: object, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<PreservationJobsModel>>;
    public preservationPlanningPreservationJobsPost(body?: object, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        let headers = this.defaultHeaders;

        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
            'application/hal+json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected !== undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
            'application/json'
        ];
        const httpContentTypeSelected: string | undefined = this.configuration.selectHeaderContentType(consumes);
        if (httpContentTypeSelected !== undefined) {
            headers = headers.set('Content-Type', httpContentTypeSelected);
        }

        return this.httpClient.post<PreservationJobsModel>(`${this.configuration.basePath}/preservation-planning/preservation-jobs`,
            body,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * 
     * @param resId Resource Id (GUID)
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public resourceSrvApplicationRolesDeleteById(resId: string, observe?: 'body', reportProgress?: boolean): Observable<ApplicationRolesModel>;
    public resourceSrvApplicationRolesDeleteById(resId: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<ApplicationRolesModel>>;
    public resourceSrvApplicationRolesDeleteById(resId: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<ApplicationRolesModel>>;
    public resourceSrvApplicationRolesDeleteById(resId: string, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (resId === null || resId === undefined) {
            throw new Error('Required parameter resId was null or undefined when calling resourceSrvApplicationRolesDeleteById.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
            'application/hal+json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected !== undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
        ];

        return this.httpClient.delete<ApplicationRolesModel>(`${this.configuration.basePath}/resource-srv/application-roles/${encodeURIComponent(String(resId))}`,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * 
     * @param size The page size
     * @param page The current page number
     * @param sort To sort on a field. By default, the sort is ascending. desc option \&#39;[,desc]\&#39; permits to have descending order.
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public resourceSrvApplicationRolesGet(size?: number, page?: number, sort?: string, observe?: 'body', reportProgress?: boolean): Observable<CollectionModel>;
    public resourceSrvApplicationRolesGet(size?: number, page?: number, sort?: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<CollectionModel>>;
    public resourceSrvApplicationRolesGet(size?: number, page?: number, sort?: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<CollectionModel>>;
    public resourceSrvApplicationRolesGet(size?: number, page?: number, sort?: string, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        let queryParameters = new HttpParams({encoder: new CustomHttpUrlEncodingCodec()});
        if (size !== undefined && size !== null) {
            queryParameters = queryParameters.set('size', <any>size);
        }
        if (page !== undefined && page !== null) {
            queryParameters = queryParameters.set('page', <any>page);
        }
        if (sort !== undefined && sort !== null) {
            queryParameters = queryParameters.set('sort', <any>sort);
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
            'application/hal+json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected !== undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
        ];

        return this.httpClient.get<CollectionModel>(`${this.configuration.basePath}/resource-srv/application-roles`,
            {
                params: queryParameters,
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * 
     * @param resId Resource Id (GUID)
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public resourceSrvApplicationRolesGetById(resId: string, observe?: 'body', reportProgress?: boolean): Observable<ApplicationRolesModel>;
    public resourceSrvApplicationRolesGetById(resId: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<ApplicationRolesModel>>;
    public resourceSrvApplicationRolesGetById(resId: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<ApplicationRolesModel>>;
    public resourceSrvApplicationRolesGetById(resId: string, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (resId === null || resId === undefined) {
            throw new Error('Required parameter resId was null or undefined when calling resourceSrvApplicationRolesGetById.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
            'application/hal+json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected !== undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
        ];

        return this.httpClient.get<ApplicationRolesModel>(`${this.configuration.basePath}/resource-srv/application-roles/${encodeURIComponent(String(resId))}`,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * 
     * @param resId Resource Id (GUID)
     * @param body 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public resourceSrvApplicationRolesPatchById(resId: string, body?: object, observe?: 'body', reportProgress?: boolean): Observable<ApplicationRolesModel>;
    public resourceSrvApplicationRolesPatchById(resId: string, body?: object, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<ApplicationRolesModel>>;
    public resourceSrvApplicationRolesPatchById(resId: string, body?: object, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<ApplicationRolesModel>>;
    public resourceSrvApplicationRolesPatchById(resId: string, body?: object, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (resId === null || resId === undefined) {
            throw new Error('Required parameter resId was null or undefined when calling resourceSrvApplicationRolesPatchById.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
            'application/hal+json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected !== undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
            'application/json'
        ];
        const httpContentTypeSelected: string | undefined = this.configuration.selectHeaderContentType(consumes);
        if (httpContentTypeSelected !== undefined) {
            headers = headers.set('Content-Type', httpContentTypeSelected);
        }

        return this.httpClient.patch<ApplicationRolesModel>(`${this.configuration.basePath}/resource-srv/application-roles/${encodeURIComponent(String(resId))}`,
            body,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * 
     * @param body 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public resourceSrvApplicationRolesPost(body?: object, observe?: 'body', reportProgress?: boolean): Observable<ApplicationRolesModel>;
    public resourceSrvApplicationRolesPost(body?: object, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<ApplicationRolesModel>>;
    public resourceSrvApplicationRolesPost(body?: object, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<ApplicationRolesModel>>;
    public resourceSrvApplicationRolesPost(body?: object, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        let headers = this.defaultHeaders;

        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
            'application/hal+json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected !== undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
            'application/json'
        ];
        const httpContentTypeSelected: string | undefined = this.configuration.selectHeaderContentType(consumes);
        if (httpContentTypeSelected !== undefined) {
            headers = headers.set('Content-Type', httpContentTypeSelected);
        }

        return this.httpClient.post<ApplicationRolesModel>(`${this.configuration.basePath}/resource-srv/application-roles`,
            body,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * 
     * @param resId Resource Id (GUID)
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public resourceSrvBasicAuthClientsDeleteById(resId: string, observe?: 'body', reportProgress?: boolean): Observable<BasicAuthClientsModel>;
    public resourceSrvBasicAuthClientsDeleteById(resId: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<BasicAuthClientsModel>>;
    public resourceSrvBasicAuthClientsDeleteById(resId: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<BasicAuthClientsModel>>;
    public resourceSrvBasicAuthClientsDeleteById(resId: string, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (resId === null || resId === undefined) {
            throw new Error('Required parameter resId was null or undefined when calling resourceSrvBasicAuthClientsDeleteById.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
            'application/hal+json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected !== undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
        ];

        return this.httpClient.delete<BasicAuthClientsModel>(`${this.configuration.basePath}/resource-srv/basic-auth-clients/${encodeURIComponent(String(resId))}`,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * 
     * @param size The page size
     * @param page The current page number
     * @param sort To sort on a field. By default, the sort is ascending. desc option \&#39;[,desc]\&#39; permits to have descending order.
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public resourceSrvBasicAuthClientsGet(size?: number, page?: number, sort?: string, observe?: 'body', reportProgress?: boolean): Observable<CollectionModel>;
    public resourceSrvBasicAuthClientsGet(size?: number, page?: number, sort?: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<CollectionModel>>;
    public resourceSrvBasicAuthClientsGet(size?: number, page?: number, sort?: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<CollectionModel>>;
    public resourceSrvBasicAuthClientsGet(size?: number, page?: number, sort?: string, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        let queryParameters = new HttpParams({encoder: new CustomHttpUrlEncodingCodec()});
        if (size !== undefined && size !== null) {
            queryParameters = queryParameters.set('size', <any>size);
        }
        if (page !== undefined && page !== null) {
            queryParameters = queryParameters.set('page', <any>page);
        }
        if (sort !== undefined && sort !== null) {
            queryParameters = queryParameters.set('sort', <any>sort);
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
            'application/hal+json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected !== undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
        ];

        return this.httpClient.get<CollectionModel>(`${this.configuration.basePath}/resource-srv/basic-auth-clients`,
            {
                params: queryParameters,
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * 
     * @param resId Resource Id (GUID)
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public resourceSrvBasicAuthClientsGetById(resId: string, observe?: 'body', reportProgress?: boolean): Observable<BasicAuthClientsModel>;
    public resourceSrvBasicAuthClientsGetById(resId: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<BasicAuthClientsModel>>;
    public resourceSrvBasicAuthClientsGetById(resId: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<BasicAuthClientsModel>>;
    public resourceSrvBasicAuthClientsGetById(resId: string, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (resId === null || resId === undefined) {
            throw new Error('Required parameter resId was null or undefined when calling resourceSrvBasicAuthClientsGetById.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
            'application/hal+json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected !== undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
        ];

        return this.httpClient.get<BasicAuthClientsModel>(`${this.configuration.basePath}/resource-srv/basic-auth-clients/${encodeURIComponent(String(resId))}`,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * 
     * @param resId Resource Id (GUID)
     * @param body 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public resourceSrvBasicAuthClientsPatchById(resId: string, body?: object, observe?: 'body', reportProgress?: boolean): Observable<BasicAuthClientsModel>;
    public resourceSrvBasicAuthClientsPatchById(resId: string, body?: object, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<BasicAuthClientsModel>>;
    public resourceSrvBasicAuthClientsPatchById(resId: string, body?: object, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<BasicAuthClientsModel>>;
    public resourceSrvBasicAuthClientsPatchById(resId: string, body?: object, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (resId === null || resId === undefined) {
            throw new Error('Required parameter resId was null or undefined when calling resourceSrvBasicAuthClientsPatchById.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
            'application/hal+json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected !== undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
            'application/json'
        ];
        const httpContentTypeSelected: string | undefined = this.configuration.selectHeaderContentType(consumes);
        if (httpContentTypeSelected !== undefined) {
            headers = headers.set('Content-Type', httpContentTypeSelected);
        }

        return this.httpClient.patch<BasicAuthClientsModel>(`${this.configuration.basePath}/resource-srv/basic-auth-clients/${encodeURIComponent(String(resId))}`,
            body,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * 
     * @param body 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public resourceSrvBasicAuthClientsPost(body?: object, observe?: 'body', reportProgress?: boolean): Observable<BasicAuthClientsModel>;
    public resourceSrvBasicAuthClientsPost(body?: object, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<BasicAuthClientsModel>>;
    public resourceSrvBasicAuthClientsPost(body?: object, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<BasicAuthClientsModel>>;
    public resourceSrvBasicAuthClientsPost(body?: object, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        let headers = this.defaultHeaders;

        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
            'application/hal+json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected !== undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
            'application/json'
        ];
        const httpContentTypeSelected: string | undefined = this.configuration.selectHeaderContentType(consumes);
        if (httpContentTypeSelected !== undefined) {
            headers = headers.set('Content-Type', httpContentTypeSelected);
        }

        return this.httpClient.post<BasicAuthClientsModel>(`${this.configuration.basePath}/resource-srv/basic-auth-clients`,
            body,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public resourceSrvGet(observe?: 'body', reportProgress?: boolean): Observable<DlcmResourceSrvModel>;
    public resourceSrvGet(observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<DlcmResourceSrvModel>>;
    public resourceSrvGet(observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<DlcmResourceSrvModel>>;
    public resourceSrvGet(observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        let headers = this.defaultHeaders;

        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
            'application/hal+json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected !== undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
        ];

        return this.httpClient.get<DlcmResourceSrvModel>(`${this.configuration.basePath}/resource-srv`,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

}
