/**
 * DLCM-Solution
 * DLCM application wrapping all modules, All-In-One
 *
 * The version of the OpenAPI document: 1.3.0-SNAPSHOT
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import { AipInfoEmbargoModel } from './aip-info-embargo.model';
import { ChangeInfoModel } from './change-info.model';


export interface DepositsModel { 
    /**
     * The access level of the deposit
     */
    access?: DepositsModel.AccessModelEnum;
    /**
     * The _links_ list of the _deposits_ resource
     */
    _links?: object;
    /**
     * The preservation policy ID of the deposit
     */
    preservationPolicyId?: string;
    /**
     * Number of deposit data files
     */
    dataFileNumber?: number;
    /**
     * The description of the deposit
     */
    description?: string;
    /**
     * The title of the deposit
     */
    title?: string;
    /**
     * The generated SIP DLCM ID of the deposit
     */
    sipId?: string;
    /**
     * The end of the deposit collection
     */
    collectionEnd?: Date;
    /**
     * The organizational unit ID of the deposit
     */
    organizationalUnitId?: string;
    /**
     * If the deposit has an embargo
     */
    hasEmbargo?: boolean;
    /**
     * The submission policy ID of the deposit
     */
    submissionPolicyId?: string;
    /**
     * The license ID of the deposit
     */
    licenseId?: string;
    /**
     * The publication date of the deposit
     */
    publicationDate?: string;
    /**
     * The creation info of the _deposits_ resource (see <<change-info>>)
     */
    creation?: ChangeInfoModel;
    /**
     * The submission agreement of the deposit
     */
    agreement?: boolean;
    /**
     * If all data file are ready
     */
    allDataFileReady?: boolean;
    /**
     * The language ID of the deposit
     */
    languageId?: string;
    /**
     * The _deposits_ resource identifier [https://en.wikipedia.org/wiki/Universally_unique_identifier[UUID]]
     */
    resId?: string;
    /**
     * The message related to the status
     */
    statusMessage?: string;
    /**
     * The submission agreement of the deposit
     */
    submissionAgreementId?: string;
    /**
     * Size of AIP collection
     */
    collectionSize?: number;
    /**
     * The last updated info of the _deposits_ resource (see <<change-info>>)
     */
    lastUpdate?: ChangeInfoModel;
    /**
     * The preparation ID of the deposit
     */
    preparationId?: string;
    embargo?: AipInfoEmbargoModel;
    /**
     * The beginning of the deposit collection
     */
    collectionBegin?: Date;
    /**
     * The status of the deposit
     */
    status?: DepositsModel.StatusModelEnum;
    /**
     * The Digital Object Identifier (DOI) of the deposit
     */
    doi?: string;
}
export namespace DepositsModel {
    export type AccessModelEnum = 'PUBLIC' | 'RESTRICTED' | 'CLOSED';
    export const AccessModelEnum = {
        PUBLIC: 'PUBLIC' as AccessModelEnum,
        RESTRICTED: 'RESTRICTED' as AccessModelEnum,
        CLOSED: 'CLOSED' as AccessModelEnum
    };
    export type StatusModelEnum = 'IN_ERROR' | 'PAUSED' | 'IN_PROGRESS' | 'IN_VALIDATION' | 'CHECKED' | 'REJECTED' | 'APPROVED' | 'SUBMITTED' | 'COMPLETED';
    export const StatusModelEnum = {
        INERROR: 'IN_ERROR' as StatusModelEnum,
        PAUSED: 'PAUSED' as StatusModelEnum,
        INPROGRESS: 'IN_PROGRESS' as StatusModelEnum,
        INVALIDATION: 'IN_VALIDATION' as StatusModelEnum,
        CHECKED: 'CHECKED' as StatusModelEnum,
        REJECTED: 'REJECTED' as StatusModelEnum,
        APPROVED: 'APPROVED' as StatusModelEnum,
        SUBMITTED: 'SUBMITTED' as StatusModelEnum,
        COMPLETED: 'COMPLETED' as StatusModelEnum
    };
}

