/**
 * DLCM-Solution
 * DLCM application wrapping all modules, All-In-One
 *
 * The version of the OpenAPI document: 1.3.0-SNAPSHOT
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import { AipInfoModel } from './aip-info.model';
import { ChangeInfoModel } from './change-info.model';


export interface SipModel { 
    /**
     * The source deposit ID of the SIP
     */
    depositId?: string;
    /**
     * The _links_ list of the _sip_ resource
     */
    _links?: object;
    /**
     * Number of SIP data files
     */
    dataFileNumber?: number;
    /**
     * Mandatory step to approve the AIP disposition
     */
    dispositionApproval?: boolean;
    /**
     * The generated AIP DLCM ID of the SIP
     */
    aipId?: string;
    /**
     * The _sip_ resource identifier [https://en.wikipedia.org/wiki/Universally_unique_identifier[UUID]]
     */
    resId?: string;
    /**
     * If the SIP package is ready
     */
    ready?: boolean;
    /**
     * Size of AIP collection
     */
    collectionSize?: number;
    /**
     * The last updated info of the _sip_ resource (see <<change-info>>)
     */
    lastUpdate?: ChangeInfoModel;
    /**
     * The retention duration in human-readable format of the AIP
     */
    smartRetention?: string;
    /**
     * The retention duration in days of the AIP
     */
    retention?: number;
    /**
     * The creation info of the _sip_ resource (see <<change-info>>)
     */
    creation?: ChangeInfoModel;
    info?: AipInfoModel;
}

