import {ChangeDetectionStrategy, Component, EventEmitter, Input, OnInit, Output} from '@angular/core';
import {DepositsModel, OrganizationalUnitsModel} from '@app/generated-api';
import {FieldTypeEnum} from '@app/shared/enums/field-type.enum';
import {DataTableColumnsModel} from '@app/shared/models/data-table-columns.model';
import {TranslateService} from '@ngx-translate/core';

@Component({
  selector: 'dlcm-table',
  templateUrl: './table.component.html',
  styleUrls: ['./table.component.scss'],
  changeDetection: ChangeDetectionStrategy.OnPush,
})
export class TableComponent implements OnInit {
  @Input()
  organizationalUnits: OrganizationalUnitsModel[];

  @Output()
  selectEvent: EventEmitter<string>;

  columns: DataTableColumnsModel[];

  constructor(private translate: TranslateService) {
    this.selectEvent = new EventEmitter<string>();
  }

  ngOnInit() {
    // TODO Use typeof to get interface propertie name
    this.columns = [
      {field: 'name', header: this.translate.instant('table.header.name')},
      {field: 'description', header: this.translate.instant('table.header.description')},
      {field: 'creation.when', header: this.translate.instant('table.header.creation.when'), type: FieldTypeEnum.datetime},
    ];
  }

  showDetail(deposit: DepositsModel) {
    this.selectEvent.emit(deposit.resId);
  }
}
