import {NgModule} from '@angular/core';
import {RouterModule, Routes} from '@angular/router';
import {OrganizationalUnitRoutesEnum} from '@app/shared/enums/routes.enum';
import {AppRoutesEnum} from '@app/module/app-routing.module';
import {CreateView} from '@app/organizational-unit/views/create/create.view';
import {EditView} from '@app/organizational-unit/views/edit/edit.view';
import {ListView} from '@app/organizational-unit/views/list/list.view';
import {DetailView} from '@app/organizational-unit/views/detail/detail.view';

const routes: Routes = [
  {
    path: '',
    component: ListView,
  },
  {
    path: OrganizationalUnitRoutesEnum.detail + AppRoutesEnum.separator + AppRoutesEnum.paramId,
    component: DetailView,
  },
  {
    path: OrganizationalUnitRoutesEnum.edit + AppRoutesEnum.separator + AppRoutesEnum.paramId,
    component: EditView,
  },
  {
    path: OrganizationalUnitRoutesEnum.create,
    component: CreateView,
  },
];

@NgModule({
  imports: [RouterModule.forChild(routes)],
  exports: [RouterModule],
})
export class OrganizationalUnitRoutingModule {
}
