import {NgModule} from '@angular/core';
import {TableComponent} from '@app/organizational-unit/components/table/table.component';
import {OrganizationalUnitRoutingModule} from '@app/organizational-unit/organizational-unit-routing.module';
import {OrganizationalUnitState} from '@app/organizational-unit/organizational-unit.state';
import {SharedModule} from '@app/shared/shared.module';
import {TranslateModule} from '@ngx-translate/core';
import {NgxsModule} from '@ngxs/store';
import {CreateComponent} from './components/create/create.component';
import {DetailComponent} from './components/detail/detail.component';
import {DeleteDialog} from './dialogs/delete/delete.dialog';
import {CreateView} from './views/create/create.view';
import {EditView} from './views/edit/edit.view';
import {ListView} from './views/list/list.view';
import {DetailView} from './views/detail/detail.view';

const views = [
  DetailView,
  ListView,
  CreateView,
  EditView,
];
const containers = [];
const dialogs = [
  DeleteDialog,
];
const components = [
  TableComponent,
  CreateComponent,
  DetailComponent,
];

@NgModule({
  declarations: [
    ...views,
    ...containers,
    ...dialogs,
    ...components,
  ],
  imports: [
    SharedModule,
    OrganizationalUnitRoutingModule,
    TranslateModule.forChild({}),
    NgxsModule.forFeature([
      OrganizationalUnitState,
    ]),
  ],
  entryComponents: [
    ...dialogs,
  ],
  exports: [
    ...views,
  ],
  providers: [],
})
export class OrganizationalUnitModule {
}
