import {Directive, OnDestroy} from '@angular/core';
import {Subscription} from 'rxjs';

@Directive({
  selector: 'dlcm-base',
})
export class BaseDirective implements OnDestroy {
  private listSubscription: Subscription[];

  constructor() {
    this.listSubscription = [];
  }

  ngOnDestroy(): void {
    this.listSubscription.forEach((subscription: Subscription) => {
      if (subscription) {
        subscription.unsubscribe();
      }
    });
  }

  addToSubscription(subscription: Subscription) {
    this.listSubscription.push(subscription);
  }
}
